<?php
/*
 +----------------------------------------------------
 |  Multi system integration
 |  (c) 2004-2009 BBPixel.com
 +----------------------------------------------------
 |  Initial controller
 |  Revision: 0905160003 $
 |  Since: 2008-May-01
 |  Author: Koudanshi (sales@bbpixel.com)
 |  License: Commercial
 +----------------------------------------------------
 */

define( "ROOT_PATH", dirname(__FILE__) );

if (!defined("MSI_SYSTEM")) die("You do not allow to access this file directly");
// Global config
$version = "1.0";

// Error reporting config
error_reporting(E_ALL);

// Include lib
require_once(ROOT_PATH.'/config.php');
require_once(ROOT_PATH.'/lib/class_db_'.$msiCFG['type'].'.php');
require_once(ROOT_PATH.'/lib/class_main.php');
require_once(ROOT_PATH.'/lib/class_session.php');
require_once(ROOT_PATH.'/lib/class_display.php');
require_once(ROOT_PATH.'/lib/func_core.php');

// Create global class
$msiPixel = new mainPixel();

// Global constant
define("SITE_URL", $msiPixel->_cfg['url']);

// Create DB connection
$msiPixel->db = new dbPixel();
$msiPixel->db->_obj = $msiPixel->_cfg;
$msiPixel->db->connect();

// Init Session
$msiPixel->sess = new sessPixel($msiPixel->db);
$isLoggedIn = $msiPixel->sess->isLogin();

// Init display
$msiPixel->disp = new dispPixel();

//----#### Parse template ####----//
$tplData = array();
$msiPixel->disp->_tplVar = array('tplData');

//----#### Parse language ####----//
$fileLang = ROOT_PATH.'/languages/'.$msiPixel->_cfg['lang'].'.php';

if ( file_exists($fileLang) )
{
	require($fileLang);
}
else
{
	require(ROOT_PATH.'/languages/en.php');
}

//----#### Actions ####----//
$system 	= $msiPixel->get('s', 'STR');
$engine 	= $msiPixel->get('e', 'STR');
$action 	= $msiPixel->get('act', 'STR');
$do 		= $msiPixel->get('do','STR');

// Left menu navigation building

//-----------------------------------------------
//--- Hooks :: menu_left
//-----------------------------------------------
$tplData['menu_left'] = array();
$plugins = getDB(0, '', 'all');

foreach ( $plugins as $plugin )
{
	$file_hook 	= ROOT_PATH.'/plugins/'.$plugin['name'].'/menu.php';
	if ( file_exists($file_hook) )
	{
		require($file_hook);
	}
}

// menuID
$tplData['menu'] = 'user'; // default
if ( $system == 'core' and !empty($engine) )
{
	$tplData['menu'] = $engine;
}
else if ( !empty($system) )
{
	$tplData['menu'] = $system;
}

$tplData['title'] 		= "BBPixel MSI";
$tplData['url'] 		= SITE_URL;
$tplData['styleURL'] 	= SITE_URL.'/templates/'.$msiPixel->_cfg['tplName'];
$tplData['minPwd']		= $msiPixel->_cfg['minPwd'];
$tplData['classes'] 	= "";//enable separately
$tplData['ver'] 		= $version;
$tplData['logout']		= "";
if ( $isLoggedIn )
{
	$tplData['logout'] 	= <<<HTM
	<div class="topright"><a href="{$tplData['url']}/login.php?act=logout"><img src="{$tplData['styleURL']}/images/icon_poff.png" alt="logout"/></a></div>
HTM;
}
$tplData['start'] 		= $msiPixel->disp->loadFile('htm_start.tpl');
$tplData['end'] 		= $msiPixel->disp->loadFile('htm_end.tpl');
$tplData['header'] 		= $msiPixel->disp->loadFile('header.tpl');
$tplData['footer'] 		= $msiPixel->disp->loadFile('footer.tpl');
$tplData['left'] 		= $msiPixel->disp->loadFile('left.tpl');
//$tplData['right'] 	= $msiPixel->disp->loadFile('right.tpl');
$tplData['right'] 		= "";
$tplData['main'] 		= "";


?>