<?php
/*
 +----------------------------------------------------
 |  Multi system integration
 |  (c) 2004-2009 BBPixel.com
 +----------------------------------------------------
 |  Installer
 |  Revision: 091023 $
 |  Since: 2008-May-01
 |  Author: Koudanshi (sales@bbpixel.com)
 |  License: Commercial
 +----------------------------------------------------
 */

define('ROOT_PATH', './');
$version = '1.0';
// Include lib
require_once(ROOT_PATH.'/config.php');
require_once(ROOT_PATH.'/lib/class_db_mysql.php');
require_once(ROOT_PATH.'/lib/class_main.php');
require_once(ROOT_PATH.'/lib/class_session.php');
require_once(ROOT_PATH.'/lib/class_display.php');
require_once(ROOT_PATH.'/lib/func_core.php');

// Create global class
$msiPixel = new mainPixel();

// Global constant
define("SITE_URL", $msiPixel->_cfg['url']);

// Create DB connection
$msiPixel->db = new dbPixel();
$msiPixel->db->_obj = $msiPixel->_cfg;
$msiPixel->db->connect();

// Init Session
//$msiPixel->sess = new sessPixel($msiPixel->db);
//$isLoggedIn = $msiPixel->sess->isLogin();

// Init display
$msiPixel->disp = new dispPixel();


//----#### Parse template ####----//
$tplData = array();
$msiPixel->disp->_tplVar = array('tplData');

$tplData['title'] 		= "BBPixel MSI";
$tplData['url'] 		= SITE_URL;
$tplData['styleURL'] 	= SITE_URL.'/templates/'.$msiPixel->_cfg['tplName'];
$tplData['classes'] 	= ' class="auto"';//enable separately
$tplData['ver'] 		= $version;
$tplData['logout']		= "";
/*
if ( $isLoggedIn )
{
	$tplData['logout']	= <<<HTM
	<div class="topright"><a href="login.php?act=logout"><img src="{$tplData['styleURL']}/images/icon_poff.png" alt="logout"/></a></div>
HTM;
}
*/
$tplData['start'] 		= $msiPixel->disp->loadFile('htm_start.tpl');
$tplData['end'] 		= $msiPixel->disp->loadFile('htm_end.tpl');
$tplData['header'] 		= $msiPixel->disp->loadFile('header.tpl');
$tplData['footer'] 		= $msiPixel->disp->loadFile('footer.tpl');
$tplData['left'] 		= "";
//$tplData['right'] 	= $msiPixel->disp->loadFile('right.tpl');
$tplData['right'] 		= "";
$tplData['main'] 		= "";

if ( file_exists("install.lock") )
{
	$output = headOpen();
	$output .= "<tr><td>Please Remove <b>install.lock</b> before we can continue on installing processes.</td></tr>";
	$output .= headClose();

}
else
{
	/*
	//----#### Checking administrators privilege ####----//
	if ( !$isLoggedIn )
	{
		$tplData['main'] .= $msiPixel->disp->loadFile("bit/user_login.tpl");
		$msg = "Error... Please login with adimistrator privilege!";
		$msiPixel->disp->error($msg);
	}
	if ( $msiPixel->sess->_userInfo['gid'] > 1 ) // default is 1 for administrator group
	{
		//die("Sorry! You don't have permssion to access this page. Please go back and try another account.");//temporary output in raw type
		$msg = "Error... You don't have enough privilege to access this page.";
		$msiPixel->disp->error($msg);
	}
	*/
	//----#### Parse input information ####----//
	$user = array();
	$user['name'] 		= $msiPixel->get('username', 'STR');
	$user['email'] 		= $msiPixel->get('email', 'STR');
	$user['password'] 	= $msiPixel->get('password', 'STR');
	$action = $msiPixel->get('act', 'STR');

	if ( empty($action) )
	{
		$output = headOpen();
		$output .= <<<HTM
	<form name="installer" id="installer" action="install.php" method="post">
	<tr>
		<td colspan="2"><p>Welcome to BBPixel installer engine, it will help you to do installing MSI core database. Fullfill all information below and click Install to continue... </p>
	<tr>
		<td class="col-1">Username</td>
		<td><input type="text" class="required" name="username" /></td>
	</tr>
	<tr>
		<td>Email</td>
		<td><input type="text" class="required email" name="email" /></td>
	</tr>
	<tr>
		<td>Password</td>
		<td><input type="text" class="required" name="password" /></td>
	</tr>
	<tr>
		<td>&nbsp;</td>
		<td>
			<input type="hidden" name="act" value="doinstall" />
			<input type="submit" value="Install" />
		</td>
	</tr>
	</form>
	<script type="text/javascript">
	$(document).ready(function() {
		$("#installer").validate({
			rules:{
				username:{
					minlength: 3
				},
				password:{
					minlength: 6
				}
			}
		});
	});
	</script>
HTM;
		$output .= headClose();
	}
	else if ( $action == "doinstall" )
	{
		// Checking input informaiton
		if ( empty($user['name']) or empty($user['email']) or empty($user['password']))
		{
			$msg = "Error... Please fill in all require information";
			$msiPixel->disp->error($msg);
		}
		// Parse administrator password
		$salt = $msiPixel->makeSalt();
		$user['password'] = $msiPixel->encodePwd($user['password'], $salt);

		$sql = array();
		$sql[] = "DROP TABLE IF EXISTS `{$msiPixel->_cfg['prx']}activation`;";
		$sql[] = "CREATE TABLE `{$msiPixel->_cfg['prx']}activation` (
				  `id` varchar(16) NOT NULL default '',
				  `email` varchar(100) NOT NULL default '',
				  `expired` int(10) NOT NULL default '0',
				  UNIQUE KEY `email` (`email`)
				) DEFAULT CHARSET=utf8;
				";
		$sql[] = "DROP TABLE IF EXISTS `{$msiPixel->_cfg['prx']}group`;";
		$sql[] = "CREATE TABLE `{$msiPixel->_cfg['prx']}group` (
				  `id` int(10) NOT NULL auto_increment,
				  `name` varchar(100) NOT NULL default '',
				  `desc` varchar(250) NOT NULL default '',
				  `isadmin` tinyint(1) NOT NULL default '0',
				  `isuser` tinyint(1) NOT NULL default '0',
				  `isgroup` tinyint(1) NOT NULL default '0',
				  `isplugin` tinyint(1) NOT NULL default '0',
				  `issync` tinyint(1) NOT NULL default '0',
				  PRIMARY KEY  (`id`)
				) DEFAULT CHARSET=utf8 ;
				";
		$sql[] = "INSERT INTO `{$msiPixel->_cfg['prx']}group` VALUES (1, 'Admnistrator', '', 1, 0, 0, 0, 0);";
		$sql[] = "INSERT INTO `{$msiPixel->_cfg['prx']}group` VALUES (2, 'Member', '', 0, 0, 0, 0, 0);";
		$sql[] = "DROP TABLE IF EXISTS `{$msiPixel->_cfg['prx']}member`;";
		$sql[] = "CREATE TABLE `{$msiPixel->_cfg['prx']}member` (
				  `id` int(10) unsigned NOT NULL auto_increment,
				  `username` varchar(100) NOT NULL default '',
				  `nickname` varchar(100) default NULL,
				  `password` varchar(100) NOT NULL default '',
				  `email` varchar(100) NOT NULL default '',
				  `gid` varchar(100) NOT NULL default '0',
				  `joined` int(10) unsigned NOT NULL default '0',
				  `salt` varchar(5) NOT NULL default '',
				  `imp_sys` varchar(100) NOT NULL default '0',
				  PRIMARY KEY  (`id`),
				  UNIQUE KEY `email` (`email`)
				) DEFAULT CHARSET=utf8;
				";
		$sql[] = "INSERT INTO `{$msiPixel->_cfg['prx']}member` VALUES (1, '{$user['name']}', 'Administrator', '{$user['password']}', '{$user['email']}', '1', '".time()."', '{$salt}', 'core');";
		$sql[] = "DROP TABLE IF EXISTS `{$msiPixel->_cfg['prx']}plugin`;";
		$sql[] = "CREATE TABLE `{$msiPixel->_cfg['prx']}plugin` (
				  `id` int(10) NOT NULL auto_increment,
				  `name` varchar(100) NOT NULL default '',
				  `enable` tinyint(1) NOT NULL default '0',
				  `type` varchar(32) NOT NULL default 'user',
				  `total` int(10) NOT NULL default '0',
				  `dbhost` varchar(100) NOT NULL default 'localhost',
				  `dbport` varchar(32) NOT NULL default '3306',
				  `dbprefix` varchar(32) NOT NULL default '',
				  `dbcharset` varchar(32) NOT NULL default 'utf8',
				  `dbuser` varchar(100) NOT NULL default '',
				  `dbpassword` varchar(32) NOT NULL default '',
				  `dbname` varchar(100) NOT NULL default '',
				  PRIMARY KEY  (`id`),
				  UNIQUE KEY `name` (`name`)
				) DEFAULT CHARSET=utf8;
				";
		$sql[] = "INSERT INTO `{$msiPixel->_cfg['prx']}plugin` VALUES (1, 'core', 1, 'user', 0, '{$msiPixel->_cfg['host']}', '{$msiPixel->_cfg['port']}', '{$msiPixel->_cfg['prx']}', '{$msiPixel->_cfg['charset']}', '{$msiPixel->_cfg['user']}', '{$msiPixel->_cfg['pwd']}', '{$msiPixel->_cfg['name']}');";
		$sql[] = "DROP TABLE IF EXISTS `{$msiPixel->_cfg['prx']}session`;";
		$sql[] = "CREATE TABLE `{$msiPixel->_cfg['prx']}session` (
				  `id` char(40) NOT NULL default '',
				  `hash` char(32) NOT NULL default '',
				  `userid` int(11) unsigned NOT NULL default '0',
				  `lastvisit` int(10) NOT NULL default '0',
				  PRIMARY KEY  (`hash`),
				  UNIQUE KEY `id` (`id`)
				) DEFAULT CHARSET=utf8;
				";
		foreach ($sql as $item)
		{
			$msiPixel->db->query($item);
		}
		// create locked install file
		$fhandle = @fopen("install.lock", "w");

		$output = headOpen();
		$output .= <<<HTM
	<tr>
		<td><p>Installed MSI core database successfully. <br /> <br />
		Please <b><font color="red">Delete</font></b> this <b>install.php</b> file to protect our site from outside attack. <br /> <br />
		You can access MSI Admin CP <a href="index.php"><b>here</b></a>
		</p>
		</td>
	</tr>
HTM;
		$output .= headClose();
	}
}

$tplData['main'] = $output;
$outData = $msiPixel->disp->loadFile('home.tpl');
$msiPixel->disp->outPut($outData);


/**
 * Output default table header
 *
 * @return string
 */
function headOpen()
{
	$output = <<<HTM
<fieldset>
<legend>
Core engine installation
</legend>
<table class="itable">
HTM;

	return $output;
}


/**
 * Output default table footer
 *
 */
function headClose()
{
	$output = <<<HTM
</table>
HTM;
	return $output;
}

?>