<?php
/**
 +----------------------------------------------------
 |  Multi system integration
 |  (c) 2003-2008 BBPixel.com
 +----------------------------------------------------
 |  Main class
 |  $Revision: 0905160002 $
 |  Author: Koudanshi (sales@bbpixel.com)
 |  License: Ecommercial
 +----------------------------------------------------
 */


class mainPixel
{
	public $_cfg;
	public $_bbPwd;
	
	public $_expired;
	public $_memGroup = 2; //default as 2

	public $_debug = "Start to out put debug information:";

	/**
	 * constructor
	 *
	 * @return mainPixel
	 */
	public function mainPixel()
	{
		global $msiCFG;

		// parse global variable
		$this->_cfg =& $msiCFG;

		$this->_bbPwd = md5('bbpixel');
		$this->_expired = time() + 60*60*24*7; // 7 day
		
		//parse magic quotes
		$this->fixMagicQuotes();
	}


	/**
	 * GET method from global varible input
	 *
	 * @param string $key
	 * @param string $type
	 * @return string value
	 */
	public function get($key="", $type='')
	{
		$value = "";

		if (isset($_GET[$key]) and !empty($_GET[$key]))
		{
			$value = $_GET[$key];
		}
		else if (isset($_POST[$key]) and !empty($_POST[$key]))
		{
			$value = $_POST[$key];
		}
		if ($type == 'INT')
		{
			$value = intval($value);
		}
		if ($type == 'STR')
		{
			$value = addslashes($value);
		}
		return $value;
	}


	/**
	 * Generation activation key
	 *
	 * @param Interger $len length of key
	 * @return string Activation key
	 */
	public function genActKey($len=16)
	{
		$charset = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
		$key = "";
		for ($i=0; $i<$len; $i++)
		{
			$key .= $charset[(mt_rand(0,(strlen($charset)-1)))];
		}
		return $key;
	}


	/**
	 * Restore encoded password to raw state
	 *
	 * @param string encoded $pwd
	 * @param string salt
	 * @return string Raw password
	 */
	public function restorePwd($pwd="", $salt="")
	{

	    $pName = $this->get('name');

	    // make sure we are doing on core database
	    if ( $pName == "core" )
	    {
	        // make sure is not a temp password
    	    if ( $pwd != $this->_bbPwd )
    	    {
                $rawPwd = $this->decodePwd($pwd, $salt);
                return $rawPwd;
    	    }
	    }
	    return $this->_bbPwd;
	}



    /**
     * Format UNIX time
     *
     * @param INT $time
     * @return string $date UNIX/SQL time stamp
     */
	public function formatUnixDate($time="")
	{
        // checking if valided UNIX time
        if ( strlen($time) == 10 )
        {
            $date = $time;
        }
        else
        {
            // Using internal SQL UNIX type date
			$date = !empty($time) ? "UNIX_TIMESTAMP('{$time}')" : "UNIX_TIMESTAMP(NOW())";
        }
        return $date;

	}

	/**
	 * Converting UNIX time stamp into SQL date format
	 *
	 * @param string $time UNIX/SQL time stamp
	 * @return string $date SQL time
	 */
	public function formatDate($time="")
	{
        // checking if valided UNIX time
        if ( strlen($time) == 10 )
        {
            $date = "'".date("Y-m-d", $time)."'";
        }
        else
        {
            // Using internal SQL date
			$date = !empty($time) ? "'{$time}'" : "NOW()";

        }
        return $date;

	}
	/**
	 * Set cookies
	 *
	 * @param string $name name of a cookie
	 * @param string $value value of a cookie
	 * @param integer $exp expired time
	 * @param string $path
	 * @param string $domain
	 * @param boolean $secure
	 */
	public function setCookie($name="", $value="", $exp=0, $path="", $domain="", $secure=0)
	{
		$exp = ($exp != 0) ? $exp : $this->_cfg['cookieExpire'];
		$exp = time() + $exp*60; //converting to minutes
		$path = !empty($path) ? $path :  $this->_cfg['cookiePath'];
		$domain = !empty($domain) ? $domain :  $this->_cfg['cookieDomain'];

		setcookie($name, $value, $exp, $path, $domain, $secure);
	}


	/**
	 * Get cookies value
	 *
	 * @param string $name
	 * @return string cookie value
	 */
	public function getCookie($name="")
	{
		if ( empty($name) )
		{
			return ;
		}
		if ( isset($_COOKIE[$name]) and !empty($_COOKIE[$name]) )
		{
			return $_COOKIE[$name];
		}
		return "";
	}


	/**
	 * Gerneration a salt code
	 *
	 * @param string $length
	 * @return string random keyword
	 */
	public function makeSalt($length=3)
	{
		$salt = '';
		for ($i = 0; $i < $length; $i++)
		{
			$salt .= chr(rand(33, 126));
		}
		$salt = str_replace("'", "!", $salt);
		$salt = addslashes($salt);

		return $salt;
	}


	/**
	 * Create hash password
	 * 
	 * @param string $pwd plain text password
	 * @param string $salt plain text
	 * @return hashed password
	 */
	public function encodePwd($pwd="", $salt="")
	{
		$encPwd = $this->encrypt($pwd, $salt.$this->_cfg['secKey']);
		return $encPwd;
	}


	public function decodePwd($encPwd="", $salt="")
	{
		$decPwd = $this->decrypt($encPwd, $salt.$this->_cfg['secKey']);
		return $decPwd;
	}


	/**
	 * Gerneration init vector
	 *
	 * @param unknown_type $len
	 * @return unknown
	 */

	public function genIV($len=16)
	{
	    $iv = '';
	    while ($len-- > 0) {
	        $iv .= chr(mt_rand() & 0xff);
	    }
	    return $iv;
	}


	/**
	 * Enscrypt a plain text with a blowfish code
	 *
	 * @param string $plain_text
	 * @param string $secKey
	 * @param integer $ivLen
	 * @return string encoded text
	 */
	public function encrypt($plain_text, $secKey, $ivLen = 16)
	{		
	    $plain_text .= "\x13";
	    $n = strlen($plain_text);

	    if ($n % 16)
	    {
	    	$plain_text .= str_repeat("\0", 16 - ($n % 16));
	    }

	    $i = 0;
	    $enc_text = $this->genIV($ivLen);
	    $iv = substr($secKey ^ $enc_text, 0, 512);

	    while ($i < $n)
	    {
	        $block = substr($plain_text, $i, 16) ^ pack('H*', md5($iv));
	        $enc_text .= $block;
	        $iv = substr($block . $iv, 0, 512) ^ $secKey;
	        $i += 16;
	    }
	    return base64_encode($enc_text);
	}


	/**
	 * Decrypt a encoded text with blowfish code
	 *
	 * @param string $enc_text
	 * @param string $secKey
	 * @param integer $ivLen
	 * @return string plain text
	 */
	public function decrypt($enc_text, $secKey, $ivLen = 16)
	{		
		$enc_text = base64_decode($enc_text);
	    $n = strlen($enc_text);
	    $i = $ivLen;
	    $plain_text = '';
	    $iv = substr($secKey ^ substr($enc_text, 0, $ivLen), 0, 512);
	    while ($i < $n)
	    {
	        $block = substr($enc_text, $i, 16);
	        $plain_text .= $block ^ pack('H*', md5($iv));
	        $iv = substr($block . $iv, 0, 512) ^ $secKey;
	        $i += 16;
	    }
	    return preg_replace('/\\x13\\x00*$/', '', $plain_text);
	}


	/**
	 * Customed addslashes function
	 *
	 * @param string $data
	 * @return escaped string
	 */
	public function addslashes($data)
	{
		$data = $this->stripslashesArray($data);
		return addslashes($data);
	}
	
	
	private function fixMagicQuotes()
	{
	   set_magic_quotes_runtime(FALSE);
	
	   if (get_magic_quotes_gpc()) 
	   {
	      $_SERVER 	= $this->stripslashesArray($_SERVER);
	      $_GET 	= $this->stripslashesArray($_GET);
	      $_POST 	= $this->stripslashesArray($_POST);
	      $_COOKIE 	= $this->stripslashesArray($_COOKIE);
	      $_FILES 	= $this->stripslashesArray($_FILES);
	      $_ENV 	= $this->stripslashesArray($_ENV);
	      $_REQUEST = $this->stripslashesArray($_REQUEST);
	      
	      if (isset($_SESSION)) /*session_start() must have been called */
	      {
	         $_SESSION = $this->stripslashesArray($_SESSION, '');
	      }
	   }
	}
	
	private function stripslashesArray($data) 
	{
		if (is_array($data))
		{
			foreach ($data as $key => $value)
			{
				$data[$key] = $this->stripslashesArray($value);
			}
			return $data;
		}
		return stripslashes($data);
	} 	

}



?>