<?php
/**
 +----------------------------------------------------
 |  Multi system integration
 |  (c) 2003-2008 BBPixel.com
 +----------------------------------------------------
 |  Session class
 |  $Revision: 0905160002 $
 |  Author: Koudanshi (sales@bbpixel.com)
 |  License: Ecommercial
 +----------------------------------------------------
 */

class sessPixel
{

	public $_userInfo;
	private $_db;

	public function sessPixel(&$db)
	{
		$this->_db = $db;
	}



	public function doLogout()
	{
		global $msiPixel;

		// Remove cookies
		$msiPixel->setCookie('msi_sessid', 0, -20000);
		$msiPixel->setCookie('msi_userid', 0, -20000);

		// Reset database session
		$curSessID = $this->genID();
		$this->update($curSessID, 0);
	}



	/**
	 * Checking a user is logged in or not
	 *
	 * @return boolean
	 */
	public function isLogin()
	{
		global $msiPixel;

		//Cookies session ID
		$cookieSessID = $msiPixel->getCookie('msi_sessid');
		$cookieUserID = $msiPixel->getCookie('msi_userid');

		//Internal session ID
		$curSessID = $this->genID();

		if ( !empty($cookieSessID) and !empty($cookieUserID) and $cookieSessID === $curSessID )
		{
			//get user logged info and checking permission
			$this->_userInfo = $this->getUserInfo($cookieUserID);

			//existed a session in database?
			if ( $this->isValid($cookieSessID, $cookieUserID) === true )
			{
				$this->update($cookieSessID, $cookieUserID);

				return true;
			}
		}
		else
		{
			// Create new guest database session
			if ( !$this->isValid($curSessID) )
			{
				$this->add();
			}
			else
			{
				//update current guest database session
				$this->update($curSessID, 0);
			}
		}
		return false;
	}



	/**
	 * Get User Information from member table
	 *
	 * @param integer $userID
	 * @return Array user info
	 */

	function getUserInfo($userID=0)
	{
		if (!$userID) return false;

		$sql = "SELECT * FROM {$this->_db->_obj['prx']}member
					WHERE id='{$userID}'
						LIMIT 1";
		$row = $this->_db->queryF($sql);

		return $row;
	}





	/**
	 * Checking a session ID is existed or not
	 *
	 * @param string $sessID session ID
	 * @param string $userID user ID
	 * @return boolean true/false
	 */
	function isValid($sessID="", $userID=0)
	{

		$userID = intval($userID);

		if ($userID)
		{
			$condition = "AND userid = {$userID}";
		}
		else
		{
			$condition = '';
		}

		$sql = "SELECT id FROM {$this->_db->_obj['prx']}session
					WHERE id='{$sessID}' {$condition}";
		$row = $this->_db->queryF($sql);

		if (!empty($row['id']))
		{
			return true;
		}
		return false;
	}

	/**
	 * Update a database session
	 *
	 * @param string $sessID session ID
	 */
	function update($sessID="", $userID=0)
	{
		if ( empty($sessID) )
		{
			return ;
		}

		$curTime = time();
		$sql = "UPDATE {$this->_db->_obj['prx']}session
				SET lastvisit = '{$curTime}',
				userid = $userID
				WHERE id = '{$sessID}'";
		$this->_db->query($sql);
	}


	/**
	 * Make new session
	 *
	 */
	function add()
	{
		$id = $this->genID();
		$hash = $this->genHash();

		$sql = "INSERT INTO {$this->_db->_obj['prx']}session
				(`id`, `hash`, `userid`)
				VALUES
				('{$id}', '{$hash}', 0)
				";
		$this->_db->query($sql);
	}

	/**
	 * Delete a session
	 *
	 */
	function remove()
	{
		$id = $this->genID();

		$sql = "DELETE FROM {$this->_db->_obj['prx']}session WHERE id = '{$id}'";
		$this->_db->query($sql);
	}


	/**
	 * Generating Session Hash
	 *
	 * @return string hash
	 */
	function genHash()
	{
		return sha1(uniqid(microtime()));
	}

	/**
	 * Generating Session ID
	 *
	 * @return string ID
	 */
	function genID()
	{
		global $msiPixel;

		$userIP = $this->getClientIP();
		$userAgent = isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : '';

		return sha1($userIP.$userAgent.sha1($msiPixel->_cfg['secKey']));
	}



	/**
	 * Fetch user IP address
	 * @return string IP
	 */

	function getClientIP()
	{
		$cur_ip = isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : 0;

		if (isset($_SERVER['HTTP_CLIENT_IP']))
		{
			$cur_ip = $_SERVER['HTTP_CLIENT_IP'];
		}
		else if (isset($_SERVER['HTTP_X_FORWARDED_FOR']) AND preg_match_all('#\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}#s', $_SERVER['HTTP_X_FORWARDED_FOR'], $matches))
		{
			// make sure we dont pick up an internal IP defined by RFC1918
			foreach ($matches[0] AS $ip)
			{
				if (!preg_match('#^(10|172\.16|192\.168)\.#', $ip))
				{
					$cur_ip = $ip;
					break;
				}
			}
		}
		else if (isset($_SERVER['HTTP_FROM']))
		{
			$cur_ip = $_SERVER['HTTP_FROM'];
		}

		return $cur_ip;
	}



}

?>