<?php
function getDB($id=0, $name='', $type='', $exclude='')
{
	global $msiPixel;

	if ( $id === 0 and $name === '' )
	{
		$condition = (empty($type)) ? "type = 'user'" : "type = '{$type}'";
		if ( $type == "all" )
		{
			$condition = "type <> ''";
		}
		if ($exclude != '')
		{
			$condition .= " AND name <> '{$exclude}'";
		}
	}
	else if ($id !== 0 and $name === '')
	{
		$condition = "id = $id";
	}
	else
	{
		$condition = "name = '{$name}'";
	}
	$db = "";
	$sql = "SELECT * FROM {$msiPixel->db->_obj['prx']}plugin
				WHERE enable = 1
				AND $condition
					ORDER BY ID ASC";

	if ($id == 0 and $name == '')
	{
		$result = $msiPixel->db->query($sql);
		while ($r = $msiPixel->db->fetchArray($result)) {
			$db[] = $r;
		}
	}
	else
	{
		$db = $msiPixel->db->queryF($sql);
	}
	return $db;
}



function newDB($db=array(), &$intDB)
{
	global $msiCFG;

	require_once('class_db_'.$msiCFG['type'].'.php');

	$extDB = new dbPixel();
	$extDB->_obj['host'] 	= $db['dbhost'];
	$extDB->_obj['port'] 	= $db['dbport'];
	$extDB->_obj['prx'] 	= $db['dbprefix'];
	$extDB->_obj['charset'] = $db['dbcharset'];
	$extDB->_obj['user'] 	= $db['dbuser'];
	$extDB->_obj['pwd'] 	= $db['dbpassword'];
	$extDB->_obj['name'] 	= $db['dbname'];
	$extDB->connect();

	// php versions before 4.2.0 do nasty things with multiple connections to the same server
	if (($extDB->_connID === $intDB->_connID) )//AND phpversion() < '4.2.0')
	{
		$extDB->_require_db_reselect = true;
		$intDB->_require_db_reselect = true;
	}

	return $extDB;
}



function build_sql($field="", $value="")
{
	$fieldBit = "";

}



function isEmail($email)
{
	$email = trim($email);
	$email = str_replace( " ", "", $email );

	// Check for more than 1 @ symbol
	if ( substr_count( $email, '@' ) > 1 )
	{
		return FALSE;
	}

	if ( preg_match( "#[\;\#\n\r\*\'\"<>&\%\!\(\)\{\}\[\]\?\\/\s]#", $email ) )
	{
		return FALSE;
	}
	else if ( preg_match( "/^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,4}|[0-9]{1,4})(\]?)$/", $email) )
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}



/**
 * Checking user info is duplicated or not
 *
 * @param object $db reference database
 * @param array $user input user info
 * @return boolean true if it is duplicated and viceversa
 */
function chk_user(&$db, $user=array())
{
	$sql = "SELECT id FROM {$db->_obj['prx']}member
				WHERE lower({$user['key']}) = '{$user['value']}'
					LIMIT 1";

	$row = $db->queryF($sql);
	if (!empty($row['id']) and $row['id'] > 0 )
	{
		return true;
	}
	return false;
}


/**
 * Get user info
 *
 * @param object $db reference database
 * @param integer $userID
 * @return Array of user info
 */
function get_user(&$db, $userID=0)
{
	if ( !$userID ) return;

	$sql = "SELECT * FROM {$db->_obj['prx']}member
				WHERE id = {$userID}'
					LIMIT 1";

	$row = $db->queryF($sql);

	return $row;
}



/**
 * Make Usergroup list
 *
 * @param object $db database
 * @param object $data template data
 * @return array list
 */
function makeListUsergroup(&$db, &$data)
{
	global $msiPixel;

	//------------------------------------------------
	//--- Get usergroup list
	//------------------------------------------------

	$sql = "SELECT id, name FROM {$db->_obj['prx']}group WHERE 1";
	$result = $db->query($sql);

	while ($r = $db->fetchArray($result)) {
		$data['groupid'][$r['id']] = $r['name'];
	}

	$list = $msiPixel->disp->loadFile('bit/list_usergroup.tpl');

	return $list;
}


/**
 * Parse redirect URL for remote request
 * Cookies storage checking support
 */
function parseRedirectURL()
{
	global $msiCFG, $msiPixel;

	$msiURL = !empty($msiCFG['urlAlias']) ? $msiCFG['urlAlias'] : $msiCFG['url'];
	$url 	= $msiPixel->get('redirect', 'STR');

	if ( !empty($url) )
	{
		$url = str_replace("_", "&", $url);
		$msiPixel->setCookie('msi_redirect', $url);
	}
	else
	{
		if ( isset($_COOKIE['msi_redirect']) and !empty($_COOKIE['msi_redirect']) )
		{
			$url = $_COOKIE['msi_redirect'];
		}
		else
		{
			$url = $msiURL;
		}
	}
	return $url;
}

?>