<?php
/*
 +----------------------------------------------------
 |  Multi system integration
 |  (c) 2004-2009 BBPixel.com
 +----------------------------------------------------
 |  Login controller
 |  Revision: 0905160003 $
 |  Since: 2008-May-01
 |  Author: Koudanshi (sales@bbpixel.com)
 |  License: Commercial
 +----------------------------------------------------
 */


define("MSI_SYSTEM", 1);

require_once (dirname(__FILE__).'/init.php');

//----#### Initial template ###----//
$fullBody = "class=\"full\"";
$leftData = "";

//----#### Actions ###----//
$action 	= $msiPixel->get('act', 'STR');
$do 		= $msiPixel->get('do','STR');

//----### Show login form ###----//
if ($action == "login")
{
	$loginForm = $msiPixel->disp->loadFile('bit/user_login.tpl');
	echo $loginForm;

}
//----### Do login action ###----//
if ($action == "dologin")
{
	$user = array();
	$user['email'] 		= $msiPixel->get('email', 'STR');
	$user['password'] 	= $msiPixel->get('password', 'STR');

	if ( empty($user['email']) or empty($user['password']) )
	{
		$msg = "Error... Missing email address/password. Please go back and try again.";
		$msiPixel->disp->error($msg);
	}
	else
	{
		//Email checking
		$sql = "SELECT id, password, gid, salt, imp_sys FROM {$msiPixel->db->_obj['prx']}member WHERE lower(email) = '{$user['email']}'";
		$row = $msiPixel->db->queryF($sql);

		if ( !empty($row['id']) and $row['id'] != 0 and $row['imp_sys'] == "core" )
		{
			//Password checking
			$salt = addslashes($row['salt']);
			$dbRawPwd = $msiPixel->decodePwd($row['password'], $salt);

			if ( $user['password'] == $dbRawPwd )
			{
				//Permission checking
				if ( $row['gid'] != 1 ) // admin group
				{
					$msg = "Error... You do not have sufficient permssion to access this page.";
					$msiPixel->disp->error($msg);
				}

				//Passed both email and password
				$curTime 	= time();
				$userID 	= $row['id'];
				$sessID 	= $msiPixel->sess->genID();

				//------------------------------------------------
				//- Store to database
				//------------------------------------------------

				// Delete expire session records
				$expTime = time() - $msiPixel->_cfg['sessTime']*60;
				$sql = "DELETE FROM {$msiPixel->db->_obj['prx']}session WHERE lastvisit <= '{$expTime}'";
				$msiPixel->db->query($sql);

				//Create new session if is not exist
				if ( !$msiPixel->sess->isValid($sessID) )
				{
					$msiPixel->sess->add();
				}

				//Update current session with new user info
				$sql = "UPDATE {$msiPixel->db->_obj['prx']}session
						SET userid = {$userID}, lastvisit = '{$curTime}'
						WHERE id = '{$sessID}'";
				$msiPixel->db->query($sql);

				//------------------------------------------------
				//- Store for cookies
				//------------------------------------------------
				$msiPixel->setCookie('msi_sessid', $sessID);
				$msiPixel->setCookie('msi_userid', $userID);

				//------------------------------------------------
				//- Password recovery for third party scripts
				//------------------------------------------------
				if ( $row['imp_sys'] != "core" and $row['imp_sys'] != "NULL" or $row['imp_sys'] == "" )
				{
					//die("passed password recovery form");
				}
				//Redirect to where it does
				$msg = "Logged in successfully.";
				$url = "ref";
				$msiPixel->disp->redirect($msg, $url);

			}
			else
			{
				$msg = "Error... Wrong password. Please go back and try again.";
				$msiPixel->disp->error($msg);
			}
		}
		else if ( $row['id'] != 0 and $row['imp_sys'] != "core" and $msiPixel->_cfg['restorePwd'] == true)
		{

			/* ### Password recovery for Core system ### */
			//-----------------------------------------------
			//--- Hooks :: isvalid_pwd
			//-----------------------------------------------
			$plugin = getDB(0, $row['imp_sys']);
	    	$file_hook 	= ROOT_PATH.'/plugins/'.$plugin['name'].'/hook.php';

	    	if ( file_exists($file_hook) )
	    	{
	    		require($file_hook);

	    		$hookClass = 'hook_'.$plugin['name'];
	    		$hookObj = new $hookClass();

	    		if ( method_exists($hookObj, "isvalid_pwd") )
	    		{
	            	//$extDB = newDB($plugin, $msiPixel->db);
	            	$salt = $row['salt']; // database user salt
	            	$rawPwd = $user['password']; // input plain text password
	            	$hashPwd = $row['password']; // database hash password
	        		$validatePwd = $hookObj->isvalid_pwd($rawPwd, $hashPwd, $salt);

	        		if ( $validatePwd === true )
	        		{
	        			//restore password to Core user system
	        			$salt = $msiPixel->makeSalt(); // generate new salt
	        			$newPwd = $msiPixel->encodePwd($rawPwd, $salt);
	        			$sql = "UPDATE {$msiPixel->db->_obj['prx']}member
	        				SET password = '{$newPwd}',
	        					salt = '{$salt}',
	        					imp_sys = 'core'
	        				WHERE id = {$row['id']}
	        			";
	        			$msiPixel->db->query($sql);

						$msg = "Warning... Your password has been restored successfully. Please go back and try again.";
						$msiPixel->disp->error($msg, 'notice');

	        		}
	        		else
	        		{
						$msg = "Error... We can not find your old password in {$plugin['name']} engine . Please go back and try again or use Recovery Password to reset your password.";
						$msiPixel->disp->error($msg);
	        		}
	    		}
	    		else
	    		{
	    		    $msg = "Can not find isvalid_pwd hook on ".$plugin['name']."engine";
	    		    $msiPixel->disp->error($msg);
	    		}
	    	}
		}
		else if ( $row['id'] and ($row['imp_sys'] == 0 or $row['imp_sys'] == 'NULL') and $msiPixel->_cfg['restorePwd'] == true )
		{
			$msg = "Error... Do not recognize import user system.";
			$msiPixel->disp->error($msg);
		}
		else
		{
			$msg = "Error... Email address not existed. Please go back and try again.";
			$msiPixel->disp->error($msg);
		}
	}

}

//----### Do logout action ###----//
if ($action == "logout")
{
	$return = $msiPixel->get('redirect', 'STR');
	$return = ($return) ? $return : $_SERVER['HTTP_REFERER'];

	$msiPixel->sess->doLogout();
	if ( !empty($return))
	{
		@header("Location: {$return}");
		exit;
	}
	//$msg = "You were logged out";
	//$msiPixel->disp->redirect($msg, $return);
}

?>