<?php
/*
 +----------------------------------------------------
 |  Multi system integration
 |  (c) 2004-2009 BBPixel.com
 +----------------------------------------------------
 |  Initial controller
 |  Revision: 0905160003 $
 |  Since: 2008-May-01
 |  Author: Koudanshi (sales@bbpixel.com)
 |  License: Commercial
 +----------------------------------------------------
 */


class hook_core
{
	/**
	 * Make core group list
	 *
	 * @param database object $db
	 * @param array of template $tplData
	 * @return string list of groups
	 */
	private function makeListUG(&$db, &$tplData)
	{
		global $msiPixel;

		$sql = "SELECT id, name FROM {$db->_obj['prx']}group WHERE 1";
		$result = $db->query($sql);

		while ($r = $db->fetchArray($result)) {
			$tplData['msi_gids'][$r['id']] = $r['name'];
		}

		$list = $msiPixel->disp->loadFile('bit/list_usergroup.tpl');

		return $list;

	}


	/**
	 * Hook edit user form
	 *
	 * @param string $db database object
	 */
	public function form_edituser(&$db, &$tplData)
	{
		global $msiPixel;

		$tplData['msi_gid'] = 0;

		if ( !empty($tplData['email']) )
		{
			// Get current userGroupID from Core
			$sql = "SELECT gid FROM {$db->_obj['prx']}member WHERE lower(email) = '{$tplData['email']}' LIMIT 1";
			$row = $db->queryF($sql);
			$tplData['msi_gid'] = intval($row['gid']);
		}

		// parse user group list
		$tplData['msi_usergroup'] = $this->makeListUG($db, $tplData);
		$form = $msiPixel->disp->loadFile('bit/form_edituser.tpl');

		return $form;

	}


	/**
	 * Hook add user
	 *
	 * @param unknown_type $user
	 */
	public function add_user(&$db, $user=array())
	{
		global $msiPixel;

		$salt = $msiPixel->makeSalt();

		$user['password'] = ($user['password'] != $msiPixel->_bbPwd) ? $msiPixel->encodePwd($user['password'], $salt) : $msiPixel->_bbPwd;

		//registered group?
		$user['msi_gid'] = $msiPixel->get('msi_gid', 'INT');
		$user['msi_gid'] = ($user['msi_gid'] > 0) ? $user['msi_gid'] : $msiPixel->_memGroup; // default register group
		if ( MSI_AREA == "USER" and $msiPixel->_cfg['validEmail'] == true )
		{
			$user['msi_gid'] = 0;
		}
		$user['imp_sys'] = !empty($user['imp_sys']) ? $user['imp_sys'] : 'core';

		$joined = $msiPixel->formatUnixDate($user['joined']);

		$sql = "INSERT INTO {$db->_obj['prx']}member
					(`username`, `nickname`, `password`, `email`, `gid`, `joined`, `salt`, `imp_sys`)
				VALUES
					('{$user['username']}', '{$user['nickname']}', '{$user['password']}', '{$user['email']}', {$user['msi_gid']}, {$joined}, '{$salt}', '{$user['imp_sys']}')
				";
		$db->query($sql);

	}


	/**
	 * Hook edit user
	 *
	 * @param array $user input member data
	 */
	public function edit_user(&$db, $user=array())
	{
        global $msiPixel;

		//registered group?
		$user['msi_gid'] = $msiPixel->get('msi_gid', 'INT');
		$userGroup = !empty($user['msi_gid']) ? "`gid` = {$user['msi_gid']}," : "";

		$sql = "UPDATE {$db->_obj['prx']}member
				SET `username` = '{$user['username']}',
					`nickname` = '{$user['nickname']}',
					`email` = '{$user['newemail']}',
					{$userGroup}
					`imp_sys` = 'core'
				WHERE lower(email) = '{$user['email']}' ";

		$db->query($sql);

		// Update user password
		if ( !empty($user['password']) )
		{
			$this->update_pwd($db, $user['password'], $user['email']);
		}
	}


	/**
	 * Update user password
	 * @param object $db database connectionn
	 * @param string $rawPwd plain text password
	 * @param string $email
	 */
	public function update_pwd(&$db, $rawPwd='', $email='')
	{
		global $msiPixel;

		if ( empty($rawPwd) or empty($email) ) return;

		$salt = $msiPixel->makeSalt();
    	$newPwd = $msiPixel->encodePwd($rawPwd, $salt);

		$sql = "UPDATE {$db->_obj['prx']}member
				SET password = '{$newPwd}',
					salt = '{$salt}'
				WHERE lower(email) = '{$email}'";
		$db->query($sql);
	}


	/**
	 * Hook delete a user
	 *
	 * @param string $db Database object of Core
	 * @param string array $user input data
	 */
	public function delete_user(&$db, $user=array())
	{
        if ( $user['email'] != null )
        {
    		foreach ($user['email'] as $email)
    		{
        		$sql = "DELETE FROM {$db->_obj['prx']}member WHERE email = '{$email}'";
        		//execute
        		$db->query($sql);
    		}
        }
	}


	/**
	 * Hook activate a user
	 *
	 * @param string $db Database object of Core
	 * @param string array $user input data
	 */
	public function activate_user(&$db, $user=array())
	{
		global $msiPixel;

		// Update user
		$sql = "UPDATE {$db->_obj['prx']}member SET gid = {$msiPixel->_memGroup} WHERE lower(email) = '{$user['email']}'";
		$db->query($sql);
	}



	/**
	 * Hook sync_count
	 *
	 * @desc Re-counting statistic users records
	 * @return array user data
	 */
	public function sync_count(&$db)
	{
		$sql = "SELECT COUNT(*) AS total FROM {$db->_obj['prx']}member
				WHERE 1";

		$result = $db->query($sql);

		$user = $db->fetchArray($result);

		return $user;
	}


	/**
	 * Hook sync_fix
	 *
	 * @desc Remove duplicate email, remove auto_increment param
	 */
	function sync_fix(&$db)
	{
		$sql = "SELECT u1.id FROM {$db->_obj['prx']}member u1, {$db->_obj['prx']}member u2
				WHERE u1.email = u2.email
				AND u1.id > u2.id";

		$result = $db->query($sql);

		while ($user = $db->fetchArray($result)) {
			$this->do_delete_user($db, $user['id']);
		}
		/// Optimize database
		$sql = "ALTER TABLE {$db->_obj['prx']}member AUTO_INCREMENT = 0";
		$db->query($sql);
	}


	/**
	 * Get users data
	 *
	 * @param object $db database
	 * @param integer $start query starts from
	 * @param integer $offset how many records per request
	 */
	public function sync_get_users(&$db, $start=0, $offset=0)
	{
		$user = array();
		$sql = "SELECT id, username, nickname, email, password, joined, salt FROM {$db->_obj['prx']}member WHERE 1 LIMIT {$start}, {$offset}";
		$result = $db->query($sql);
		while ($r = $db->fetchArray($result))
		{
			$user[] = $r;
		}
		return $user;
	}




	/**
	 * Hook sync_add_user
	 *
	 * @param object $db database
	 * @param array $user input user data
	 */
	public function sync_add_user(&$db, $user=array())
	{
	    global $msiPixel;

		//Checking duplicate username
		$uChkSql = "SELECT id, username FROM {$db->_obj['prx']}member WHERE lower(username)='".strtolower($user['username'])."' LIMIT 1";
		$uChkRow = $db->queryF($uChkSql);

		if ( $uChkRow['id'] )
		{
			$user['username'] = ucfirst(substr($user['email'], 0, strpos($user['email'], "@")));
		}

		//Checking duplicate email
		$mChkSql = "SELECT id FROM {$db->_obj['prx']}member WHERE lower(email)='".strtolower($user['email'])."' LIMIT 1";
		$mChkRow = $db->queryF($mChkSql);

		if ( !$mChkRow['id'] )
		{
		    // force to use temp password
		    // Disable now and use original password of import system
		    // $user['password'] = $msiPixel->_bbPwd;;
			$this->add_user($db, $user);
		}

	}

}

?>