<?php
/*
 +----------------------------------------------------
 |  Multi system integration
 |  (c) 2004-2009 BBPixel.com
 +----------------------------------------------------
 |  Remote controller
 |  Revision: 0905160003 $
 |  Since: 2008-May-01
 |  Author: Koudanshi (sales@bbpixel.com)
 |  License: Commercial
 +----------------------------------------------------
 */

define("MSI_SYSTEM", 1);
define("MSI_AREA", "USER");

require_once (dirname(__FILE__).'/init.php');

// Parse redirect URL from remote request script
$tplData['return'] = parseRedirectURL();

//----### Show login form ###----//
if ($action == "login")
{
	if ( $isLoggedIn === false )
	{
		require_once('config_recaptcha.php');
		echo $msiPixel->disp->loadFile('p_login.tpl');
	}
	else
	{
		$errorLoggedIn = $tplData['txt']['err_logged_in'];
		$errorLoggedIn .= "<br /> <a href='".$msiPixel->_cfg['url']."/login.php?act=logout' title='logout'>Logout</a>";
		echo $errorLoggedIn;
	}
}


//----### Do login action ###----//
if ($action == "dologin" and $isLoggedIn === false )
{
	$user = array();
	$user['email'] 		= $msiPixel->get('email', 'STR');
	$user['password'] 	= $msiPixel->get('password', 'STR');
	$user['capchallenge'] = $msiPixel->get('capchallenge', 'STR');
	$user['capresponse'] = $msiPixel->get('capresponse', 'STR');

	// Captcha checking
	require_once(ROOT_PATH.'/lib/func_recaptcha.php');

    $capResponse = recaptcha_check_answer ($privateKey,
                                    $_SERVER["REMOTE_ADDR"],
                                    $user['capchallenge'],
                                    $user['capresponse']);

	if ( empty($user['email']) or empty($user['password']) )
	{
		echo '3'; // missing email/password
		exit;
	}
	else
 	if ( empty($user['capresponse']) )
	{
		echo '4'; // missing captcha response
		exit;
	}
	else if ( !$capResponse->is_valid )
	{
		echo '5'; // captcha is not valided
		exit;
	}
	else
	{
		$sql = "SELECT id, password, salt, gid, imp_sys FROM {$msiPixel->db->_obj['prx']}member WHERE lower(email) = '{$user['email']}'";
		$row = $msiPixel->db->queryF($sql);

		if ( !empty($row['id']) and $row['id'] != 0 and $row['imp_sys'] == "core" )
		{
			//Password checking
			$salt = addslashes($row['salt']);
			$dbRawPwd = $msiPixel->decodePwd($row['password'], $salt);
			if ( $user['password'] == $dbRawPwd )
			{
				//Permission checking
				if ( $row['gid'] == 0 )
				{
					echo '6'; // you are not allowed to access this page
					exit;
				}

				//Passed both email and password
				$curTime 	= time();
				$userID 	= $row['id'];
				$sessID 	= $msiPixel->sess->genID();

				//------------------------------------------------
				//- Store to database
				//------------------------------------------------

				// Delete expire session records
				$expTime = time() - $msiPixel->_cfg['sessTime']*60;
				$sql = "DELETE FROM {$msiPixel->db->_obj['prx']}session WHERE lastvisit <= '{$expTime}'";
				$msiPixel->db->query($sql);

				//Create new session if is not exist
				if ( !$msiPixel->sess->isValid($sessID) )
				{
					$msiPixel->sess->add();
				}

				//Update current session with new user info
				$sql = "UPDATE {$msiPixel->db->_obj['prx']}session
						SET userid = {$userID}, lastvisit = '{$curTime}'
						WHERE id = '{$sessID}'";
				$msiPixel->db->query($sql);

				//------------------------------------------------
				//- Store for cookies
				//------------------------------------------------
				$msiPixel->setCookie('msi_sessid', $sessID);
				$msiPixel->setCookie('msi_userid', $userID);

				//------------------------------------------------
				//- Password recovery for third party scripts
				//------------------------------------------------
				if ( $msiPixel->_cfg['restorePwd'] === true )
				{
					$plugins = getDB(0, '', 'user', 'core');//excluded core Plugin

					if ( $plugins != null )
					{
						foreach ($plugins as $plugin)
						{
							//-----------------------------------------------
							//--- Hooks :: recover_pwd
							//-----------------------------------------------
					    	$file_hook 	= ROOT_PATH.'/plugins/'.$plugin['name'].'/hook.php';

					    	if ( file_exists($file_hook) )
					    	{
					    		require($file_hook);

					    		$hookClass = 'hook_'.$plugin['name'];
					    		$hookObj = new $hookClass();

					    		if ( method_exists($hookObj, "recover_pwd") )
					    		{
					            	$extDB = newDB($plugin, $msiPixel->db);
					            	$rawPwd = $user['password']; // input plain text password
					        		$hookObj->recover_pwd($extDB, $rawPwd, $user['email']);
					    		}
					    		else
					    		{
					    		    echo "9"; //Can not find recover_pwd hook
					    		    exit;
					    		}
					    	}//hook file exit
						}//foreach
					}
				}
				// set status
				echo "0";
				exit;
			}
			else
			{
				//$msg = "Error... Wrong password. Please try again.";
				echo '2';
				exit;
			}
		}
		else if ( !empty($row['id']) and $row['id'] != 0 and !empty($row['imp_sys']) and $row['imp_sys'] != "core" and $msiPixel->_cfg['restorePwd'] === true )
		{

			/* ### Password recovery for Core system ### */
			//-----------------------------------------------
			//--- Hooks :: isvalid_pwd
			//-----------------------------------------------
			$plugin = getDB(0, $row['imp_sys']);
	    	$file_hook 	= ROOT_PATH.'/plugins/'.$plugin['name'].'/hook.php';

	    	if ( file_exists($file_hook) )
	    	{
	    		require($file_hook);

	    		$hookClass = 'hook_'.$plugin['name'];
	    		$hookObj = new $hookClass();

	    		if ( method_exists($hookObj, "isvalid_pwd") )
	    		{
	            	//$extDB = newDB($plugin, $msiPixel->db);
	            	$salt = $row['salt']; // database user salt
	            	$rawPwd = $user['password']; // input plain text password
	            	$hashPwd = $row['password']; // database hash password
	        		$validatePwd = $hookObj->isvalid_pwd($rawPwd, $hashPwd, $salt);

	        		if ( $validatePwd === true )
	        		{
	        			//restore password to Core user system
	        			$salt = $msiPixel->makeSalt(); // generate new salt
	        			$newPwd = $msiPixel->encodePwd($rawPwd, $salt);
	        			$sql = "UPDATE {$msiPixel->db->_obj['prx']}member
	        				SET password = '{$newPwd}',
	        					salt = '{$salt}',
	        					imp_sys = 'core'
	        				WHERE id = {$row['id']}
	        			";
	        			$msiPixel->db->query($sql);
						echo "7"; //password has been restored
						exit;
	        		}
	        		else
	        		{
						echo "8"; //can not find your old password
						exit;
	        		}
	    		}
	    		else
	    		{
	    		    echo "9"; //Can not find isvalid_pwd hook
	    		    exit;
	    		}
	    	}
		}
		else if ( (empty($row['imp_sys']) or $row['imp_sys'] == 0 or $row['imp_sys'] == 'NULL') and $msiPixel->_cfg['restorePwd'] === true )
		{
			$msg = "Error... Do not recognize import user system.";
			$msiPixel->disp->error($msg);
		}
		else
		{
			//$msg = "Error... Email address not existed. Please try again.";
			echo '1';
			exit;
		}
	}

}


//----### Show register form ###----//
if ($action == "reg")
{
	require_once('config_recaptcha.php');
	echo $msiPixel->disp->loadFile('p_reg.tpl');
}



//----### Do register ###----//
if ($action == "doreg")
{
	$user = array();
	$user['username'] 	= $msiPixel->get('username', 'STR');
	$user['nickname'] 	= $msiPixel->get('nickname', 'STR');
	$user['password'] 	= $msiPixel->get('password', 'STR');
	$user['password2'] 	= $msiPixel->get('password2', 'STR');
	$user['email'] 		= $msiPixel->get('email', 'STR');
	$user['joined'] 	= time();
	$user['capchallenge'] = $msiPixel->get('capchallenge', 'STR');
	$user['capresponse'] = $msiPixel->get('capresponse', 'STR');

	// Captcha checking
	require_once(ROOT_PATH.'/lib/func_recaptcha.php');

    $capResponse = recaptcha_check_answer ($privateKey,
                                    $_SERVER["REMOTE_ADDR"],
                                    $user['capchallenge'],
                                    $user['capresponse']);

	if ( empty($user['username']) or empty($user['email']) or empty($user['password']) or empty($user['password2']) )
	{
		echo "4";
		exit;
	}
	else if ( empty($user['capresponse']) )
	{
		echo '6'; // empty captcha value
		exit;
	}
	else if ( !$capResponse->is_valid )
	{
		echo "7"; // not valided captcha
		exit;
	}
	else if (!isEmail($user['email']) )
	{
		echo "5"; // not valid email address
		exit;
	}
	else if ( chk_user($msiPixel->db, array("key" => "username", "value" => $user['username'])) === true ) //existent record found
	{
		echo "1";//username is not available
		exit;
	}

	else if ( chk_user($msiPixel->db, array("key" => "email", "value" => $user['email'])) === true ) //existent record found
	{
		echo "2";//email is not available
		exit;
	}

	else if ( $user['password'] != $user['password2'])
	{
		echo "3";//password did not match
		exit;
	}
	else
	{
		//passed all checking stuff

		//-----------------------------------------------
		//--- Hooks :: add_user
		//-----------------------------------------------
		$plugins = getDB(0);
		foreach ( $plugins as $plugin )
		{
	    	$file_hook 	= ROOT_PATH.'/plugins/'.$plugin['name'].'/hook.php';

	    	if ( file_exists($file_hook) )
	    	{
	    		require($file_hook);

				$hookClass = 'hook_'.$plugin['name'];
				$hookObj = new $hookClass();

				if ( method_exists($hookObj, "add_user") )
				{
	                $extDB = newDB($plugin, $msiPixel->db);
	    			$hookObj->add_user($extDB, $user);
				}
	    	}

		}

		$actKey = $msiPixel->genActKey();

		$sql = "REPLACE INTO {$msiPixel->db->_obj['prx']}activation (`id`, `email`, `expired`)
					VALUES ('{$actKey}', '{$user['email']}', '{$msiPixel->_expired}')";
		$msiPixel->db->query($sql);

		// Do send mail
		$content = sprintf($tplData['txt']['reg_act'], $user['username'], "{$msiPixel->_cfg['url']}/user.php?act=activate&key={$actKey}&email={$user['email']}", $msiPixel->_cfg['sitename']);
		$content = wordwrap($content, 70);
		$headers = "From: {$msiPixel->_cfg['sitename']} <{$msiPixel->_cfg['sitecontact']}>" . "\r\n" . "Reply-To: {$msiPixel->_cfg['sitename']} <{$msiPixel->_cfg['sitecontact']}>" . "\r\n" . 'X-Mailer: PHP/' . phpversion();
		$sentMail = @mail($user['email'], $tplData['txt']['reg_title'], $content, $headers);

		// set status
		echo "0";
		exit;
	}

}

//----### View userCP form ###----//
if ($action == "user")
{
	if ( $isLoggedIn )
	{
		$tplData['user'] = $msiPixel->sess->_userInfo;
		echo $msiPixel->disp->loadFile('p_user.tpl');
	}
	else
	{
		echo "{$tplData['txt']['not_login']}";
		exit;
	}
}

//----### Update userCP information ###----//
if ($action == "doedit")
{
	$user = array();
	$user['id'] 			= $msiPixel->get("id", "INT");
	$user['username'] 		= $msiPixel->get("username", "STR");
	$user['nickname'] 		= $msiPixel->get("nickname", "STR");
	$user['email'] 			= $msiPixel->get("email", "STR");
	$user['newemail'] 		= $msiPixel->get("email", "STR");
	$user['oldpassword'] 	= $msiPixel->get("oldpassword", "STR");
	$user['password'] 		= $msiPixel->get("password", "STR");
	$user['newpassword'] 	= $msiPixel->get("newpassword", "STR");

	if ( !empty($user['oldpassword']) )
	{
		//is valided old password?
		$sql = "SELECT password, salt FROM {$msiPixel->db->_obj['prx']}member WHERE lower(email) = '{$user['email']}'";
		$row = $msiPixel->db->queryF($sql);
		$salt 	= addslashes($row['salt']);
		$dbPwd 	= $msiPixel->decodePwd($row['password'], $salt);
	}
	if ( !$user['id'] or !$isLoggedIn)
	{
		echo "1"; //You must specify user id first. And make sure you are logged in
		exit;
	}
	else if ( (!empty($user['password']) or !empty($user['newpassword'])) and $user['password'] != $user['newpassword'] )
	{
		echo "2"; // password miss matched.
		exit;
	}
	else if ( !empty($user['oldpassword']) and !empty($dbPwd) and $user['oldpassword'] != $dbPwd )
	{
		echo "3";
		exit; // wrong old password
	}
	else if ( !empty($user['password']) and strlen(trim($user['password'])) < $msiPixel->_cfg['minPwd'] )
	{
		echo "4";
		exit;
	}
	else
	{
		//-----------------------------------------------
		//--- Hooks :: edit_user
		//-----------------------------------------------
		$plugins = getDB(0);
		foreach ($plugins as $plugin)
		{
	    	$file_hook 	= ROOT_PATH.'/plugins/'.$plugin['name'].'/hook.php';

	    	if ( file_exists($file_hook) )
	    	{
	    		require($file_hook);

	    		$hookClass = 'hook_'.$plugin['name'];
	    		$hookObj = new $hookClass();

	    		if ( method_exists($hookObj, "edit_user") )
	    		{
	        		$extDB = newDB($plugin, $msiPixel->db);
	                $hookObj->edit_user($extDB, $user);
	    		}
	     	}
		}
		echo "0";
		exit;
	}
}


//----### View request activation code form ###----//
if ($action == "actkey")
{
	echo $msiPixel->disp->loadFile('p_actkey.tpl');
}


//----### Do request activation code ###----//
if ($action == "doactkey")
{
	$email = $msiPixel->get('email', 'STR');
	$email = strtolower($email);

	if ( empty($email) or !isEmail($email) )
	{
		echo "1"; // empty email address or not valided email address
		exit;
	}
	else if ( chk_user($msiPixel->db, array("key" => "email", "value" => $email)) === false ) //existent record not found
	{
		echo '2'; // email not found
		exit;
	}
	else
	{
		$actKey = $msiPixel->genActKey();

		$sql = "REPLACE INTO {$msiPixel->db->_obj['prx']}activation (`id`, `email`, `expired`)
					VALUES ('{$actKey}', '{$email}', '{$msiPixel->_expired}')";
		$msiPixel->db->query($sql);

		// Do send mail
		$sql = "SELECT id, username FROM {$msiPixel->db->_obj['prx']}member
					WHERE lower(email) = '{$email}'";
		$row = $msiPixel->db->queryF($sql);

		if ( !empty($row['id']) )
		{
			$content = sprintf($tplData['txt']['act_req'], $row['username'], $actKey, "{$msiPixel->_cfg['url']}/user.php?act=activate&key={$actKey}&email={$email}", $msiPixel->_cfg['sitename']);
			$content = wordwrap($content, 70);
			$headers = "From: {$msiPixel->_cfg['sitename']} <{$msiPixel->_cfg['sitecontact']}>" . "\r\n" . "Reply-To: {$msiPixel->_cfg['sitename']} <{$msiPixel->_cfg['sitecontact']}>" . "\r\n" . 'X-Mailer: PHP/' . phpversion();
			@mail($email, $tplData['txt']['act_title'], $content, $headers);
		}

		echo "0";
		exit;
	}
}

//----### Show recovery password form ###----//
if ($action == "pwd")
{
	echo $msiPixel->disp->loadFile('p_pwd.tpl');
}

//----### Do recovery password ###----//
if ($action == "dopwd")
{
	$email = $msiPixel->get('email', 'STR');

	if ( empty($email) or !isEmail($email) )
	{
		echo "1"; // empty email address or not valided email address
		exit;
	}
	else if ( chk_user($msiPixel->db, array("key" => "email", "value" => $email)) === false ) //existent record not found
	{
		echo '2'; // email not found
		exit;
	}
	else
	{
		$reqKey = $msiPixel->genActKey();

		$sql = "REPLACE INTO {$msiPixel->db->_obj['prx']}activation (`id`, `email`, `expired`)
					VALUES ('{$reqKey}', '{$email}', '{$msiPixel->_expired}')";
		$msiPixel->db->query($sql);

		// Do email notification
		$sql = "SELECT id, username FROM {$msiPixel->db->_obj['prx']}member
					WHERE lower(email) = '{$email}'";
		$row = $msiPixel->db->queryF($sql);

		if ( !empty($row['id']) )
		{
			$content = sprintf($tplData['txt']['pwd_req'], $row['username'], "{$msiPixel->_cfg['url']}/user.php?act=dopwd&key={$reqKey}&email={$email}", $msiPixel->_cfg['sitename']);
			$content = wordwrap($content, 70);
			$headers = "From: {$msiPixel->_cfg['sitename']} <{$msiPixel->_cfg['sitecontact']}>" . "\r\n" . "Reply-To: {$msiPixel->_cfg['sitename']} <{$msiPixel->_cfg['sitecontact']}>" . "\r\n" . 'X-Mailer: PHP/' . phpversion();
			@mail($email, $tplData['txt']['pwd_req_title'], $content, $headers);
		}
		echo '0';
		exit;
	}

}


?>