<?php
/*
 +----------------------------------------------------
 |  Multi system integration
 |  (c) 2004-2009 BBPixel.com
 +----------------------------------------------------
 |  Sync controller
 |  Revision: 0905160003 $
 |  Since: 2008-May-01
 |  Author: Koudanshi (sales@bbpixel.com)
 |  License: Commercial
 +----------------------------------------------------
 */



$pName = $msiPixel->get('name', 'STR');
$id = $msiPixel->get('id', 'INT');


//----### Status ###----//
if ($action == "status")
{
	$sql = "SELECT * FROM {$msiPixel->db->_obj['prx']}plugin WHERE enable = 1";
	$result = $msiPixel->db->query($sql);

	while ($r = $msiPixel->db->fetchArray($result))
	{
		$tplData['rows'][] = $r;
	}
	$tplData['main'] .= $msiPixel->disp->loadFile('bit/sync.tpl');
}


//----### Do Count ###----//
if ($action == "docount")
{
	//-----------------------------------------------
	//- Recount statistic
	//-----------------------------------------------

	//create External DB connection
	$extDBobj 	= getDB(0, $pName);
	$extDB 		= newDB($extDBobj, $msiPixel->db);
	$file_hook 	= ROOT_PATH.'/plugins/'.$pName.'/hook.php';

	if (file_exists($file_hook))
	{
		require($file_hook);
		$hookClass 	= 'hook_'.$pName;
		$hookObj 	= new $hookClass();

		if ( method_exists($hookObj, "sync_count") )
		{
		  $user = $hookObj->sync_count($extDB);
		}
		else
		{
		    $msg = "This feature is not available yet";
		    $msiPixel->disp->error($msg);
		}
		//Update core plugin table
		$sql = "UPDATE {$msiPixel->db->_obj['prx']}plugin SET total={$user['total']} WHERE name='{$pName}'";
		$msiPixel->db->query($sql);

		// Redirect after processed successfully
		$url = "index.php?s=core&amp;e=sync&amp;act=status";
		$msg = "Re-counted statistic {$pName} user table successfully";
		$msiPixel->disp->redirect($msg, $url);

	}

}



//----### Do Count ###----//
if ($action == "docounts")
{
	//-----------------------------------------------
	//- Recount statistic
	//-----------------------------------------------
	$plugins = getDB(0);

	foreach ( $plugins as $plugin )
	{
		$file_hook = ROOT_PATH.'/plugins/'.$plugin['name'].'/hook.php';
	
		if ( file_exists($file_hook) )
		{
			require($file_hook);
			
			$hookClass 	= 'hook_'.$plugin['name'];
			$hookObj 	= new $hookClass();
	
			if ( method_exists($hookObj, "sync_count") )
			{
				//create External DB connection
				$extDB 	= newDB($plugin, $msiPixel->db);
				$user 	= $hookObj->sync_count($extDB);
			}
			else
			{
			    $msg = "This feature is not available yet";
			    $msiPixel->disp->error($msg);
			}
			//Update core plugin table
			$sql = "UPDATE {$msiPixel->db->_obj['prx']}plugin SET total={$user['total']} WHERE name='{$plugin['name']}'";
			$msiPixel->db->query($sql);	
		}
	}
	// Redirect after processed successfully
	$url = "index.php?s=core&amp;e=sync&amp;act=status";
	$msg = "Re-counted statistic of ALL user table successfully";
	$msiPixel->disp->redirect($msg, $url);
}


//----### Do Fix ###----//
if ($action == "dofix")
{
	//-----------------------------------------------
	//- Remove duplicate email address
	//-----------------------------------------------

	//create External DB connection
	$extDBobj 	= getDB(0, $pName);
	$extDB 		= newDB($extDBobj, $msiPixel->db);
	$file_hook 	= ROOT_PATH.'/plugins/'.$pName.'/hook.php';

	if (file_exists($file_hook))
	{
		require($file_hook);
		$hookClass 	= 'hook_'.$pName;
		$hookObj 	= new $hookClass();

		if ( method_exists($hookObj, "sync_fix") )
		{
            $hookObj->sync_fix($extDB);
		}
		else
		{
		    $msg = "This feature is not available yet";
		    $msiPixel->disp->error($msg);
		}

		// Redirect after processed successfully
		$msg 	= "Fixed {$pName} user table successfully";
		$msiPixel->disp->redirect($msg, 'ref');
	}

}


//----### Do Sync ###----//
if ($action == "dosync")
{
	$step 	= $msiPixel->get('step', 'INT');
	$st 	= $msiPixel->get('st', 'INT');

	// Copy user from DBn to DB0 and DBn-1
	if ($step === 1)
	{
		//-----------------------------------------------
		//--- Hooks :: sync_user
		//-----------------------------------------------
		$file_hook = ROOT_PATH.'/plugins/'.$pName.'/hook.php';

		if (file_exists($file_hook))
		{
			require($file_hook);

			//create Source DB connection
			$srcDBobj 	= getDB(0, $pName);
			$srcDB 		= newDB($srcDBobj, $msiPixel->db);
			$hookClass 	= 'hook_'.$pName;
			$hookObj 	= new $hookClass();

			if ( !method_exists($hookObj, "sync_get_users") )
			{
			    $msg = "Plugin $pName :: Sync feature is not available yet";
			    $msiPixel->disp->error($msg);
			}
			$users = $hookObj->sync_get_users($srcDB, $st, SYNC_OFFSET);

			// count to next step
			$end = $st + count($users);

			if ( $users != null )
			{
				//create Destination database connection loop
				$plugins = getDB(0, '', 'user', $pName);//excluded current Plugin name

				foreach ($plugins as $plugin)
				{
				    $file_hook = ROOT_PATH.'/plugins/'.$plugin['name'].'/hook.php';
				    if ( file_exists($file_hook) )
				    {
        				require($file_hook);
        				$destDB = newDB($plugin, $msiPixel->db);

        				$pClass = 'hook_'.$plugin['name'];
        				$pObj	= new $pClass();
        				foreach ($users as $user)
        				{
        				    if ( method_exists($pObj, "sync_add_user") )
        				    {
								// filter email address
								$user['username'] = $msiPixel->addslashes($user['username']);
								$user['nickname'] = $msiPixel->addslashes($user['nickname']);
								$user['email'] = $msiPixel->addslashes($user['email']);
            					$pObj->sync_add_user($destDB, $user);
        				    }
        				}
				    }
				}
				// Redirect after processed successfully
				$msg 	= "Synchronized up to {$end} records successfully. Continuing to next records...";
				$url	= "index.php?s=core&amp;e=sync&amp;act=dosync&amp;name={$pName}&amp;step=1&amp;st={$end}";
				$msiPixel->disp->redirect($msg, $url);
			}
			else
			{
				// Redirect after processed successfully
				$msg 	= "Synchronized successfully";
				$url	= "index.php?s=core&amp;e=sync&amp;act=docounts";
				$msiPixel->disp->redirect($msg, $url);
			}
		}
	}
}
?>