<?php
/*
 +----------------------------------------------------
 |  Multi system integration
 |  (c) 2004-2009 BBPixel.com
 +----------------------------------------------------
 |  User controller
 |  Revision: 0905160003 $
 |  Since: 2008-May-01
 |  Author: Koudanshi (sales@bbpixel.com)
 |  License: Commercial
 +----------------------------------------------------
 */



//----### View login form ###----//
if ( $action == "login" )
{
	$tplData['main'] .= $msiPixel->disp->loadFile("bit/user_login.tpl");
}

//----### Do logout ###----//
if ( $action == "logout" )
{
	$msiPixel->sess->doLogout();
	$msg = "Logged out successfully.";
	$msiPixel->disp->redirect($msg);
}


//----### View add new user form ###----//
if ( $action == "add" )
{
	//-----------------------------------------------
	//--- Hooks :: form_adduser
	//-----------------------------------------------
	$tplData['form_adduser'] = "";
	$plugins = getDB(0);

	foreach ( $plugins as $plugin )
	{
    	$file_hook 	= ROOT_PATH.'/plugins/'.$plugin['name'].'/hook.php';

    	if ( file_exists($file_hook) )
    	{
    		require($file_hook);

    		$hookClass = 'hook_'.$plugin['name'];
    		$hookObj = new $hookClass();

    		if ( method_exists($hookObj, "form_edituser") )
    		{
            	$extDB = newDB($plugin, $msiPixel->db);
        		$tplData['form_adduser'] .= $hookObj->form_edituser($extDB, $tplData);
    		}
    		else
    		{
    		    $msg = "This feature is not available yet";
    		    $msiPixel->disp->error($msg);
    		}
    	}
	}
	$tplData['main'] .= $msiPixel->disp->loadFile("bit/user_add.tpl");
}


//----### Do add new user ###----//
if ( $action == "doadd" )
{
	$user = array();
	$user['username'] 	= $msiPixel->get('username', 'STR');
	$user['nickname'] 	= $msiPixel->get('nickname', 'STR');
	$user['password'] 	= $msiPixel->get('password', 'STR');
	$user['email'] 	  	= $msiPixel->get('email', 'STR');
    $user['joined']     = time();

	//Error or empty field
	if ( empty($user['username']) or empty($user['password']) or empty($user['email']) )
	{
		$msg = "Error...missing fields username/password/email. Please go back and try again.";
		$msiPixel->disp->error($msg);
	}
	// validate email
	else if ( !empty($user['email']) and isEmail($user['email']) === false )
	{
		$msg = "Error...email address is invalid or contains illegal characters: [ ] ; # & ! * ' \" < > % ( ) { } \ ? ";
		$msiPixel->disp->error($msg);
	}
	//Duplicate username checking
	else if ( chk_user($msiPixel->db, array("key" => "username", "value" => $user['username'])) === true )
	{
		$msg = "Error...duplicate username occured, Please go back and try other one";
		$msiPixel->disp->error($msg);
	}

	//Duplicate email checking
	else if ( chk_user($msiPixel->db, array("key" => "email", "value" => $user['email'])) === true )
	{
		$msg = "Error...duplicate email address occured, Please go back and try other one";
		$msiPixel->disp->error($msg);
	}

	else
	{
		//-----------------------------------------------
		//--- Hooks :: add_user
		//-----------------------------------------------
		$plugins = getDB(0);
		//die("passed here");
		foreach ( $plugins as $plugin )
		{
        	$file_hook 	= ROOT_PATH.'/plugins/'.$plugin['name'].'/hook.php';

        	if ( file_exists($file_hook) )
        	{
        		require($file_hook);

    			$hookClass = 'hook_'.$plugin['name'];
    			$hookObj = new $hookClass();

    			if ( method_exists($hookObj, "add_user") )
    			{
                    $extDB = newDB($plugin, $msiPixel->db);
        			$hookObj->add_user($extDB, $user);
    			}
        		else
        		{
        		    $msg = "This feature is not available yet";
        		    $msiPixel->disp->error($msg);
        		}
        	}
		}

		// Redirect after processed successfully
		$msg = "Added new member successfully";
		$msiPixel->disp->redirect($msg, "ref");
	}
}


//----### View search user form ###----//
if ( $action == "search" )
{
	$tplData['main'] .= $msiPixel->disp->loadFile("bit/user_search.tpl");
}


//----### Do search user ###----//
if ( $action == "dosearch" )
{
	$user = array();
	$user['id'] 		= $msiPixel->get('id', 'INT');
	$user['username'] 	= $msiPixel->get('username', 'STR');
	$user['email'] 		= $msiPixel->get('email', 'STR');

	if ( $user['id'] == 0 and empty($user['username']) and empty($user['email']) )
	{
		$condition = '1';
	}
	else if ( $user['id'] )
	{
		$condition = "id = {$user['id']}";

	}
	else if ( !empty($user['username']) )
	{
		$condition = "username LIKE '%{$user['username']}%'";
	}
	else if ( !empty($user['email']) )
	{
		$condition = "email LIKE '%{$user['email']}%'";
	}
	
	
	
	// --------------------------------------------------------------
	// Paging navigation
	// --------------------------------------------------------------
	
	$sql = "SELECT COUNT(*) AS total FROM {$msiPixel->db->_obj['prx']}member
				WHERE $condition";
	
	$row = $msiPixel->db->queryF($sql);
	$totalRecs = $row['total'];
	$perPage = 20;
	
	$curPage = $msiPixel->get('pg', 'INT');
	$curPage = ($curPage == 0) ? 1 : $curPage;
	
	$end = ($curPage >=1) ? ($curPage - 1) * $perPage : 0;;
	
	$tplData['page'] = array();
	$tplData['page']['active'] = ($curPage) ? $curPage : 1;
	$tplData['page']['url'] = $msiPixel->_cfg['url']."/admin/index.php?s=core&e=user&act=dosearch&id={$user['id']}&username={$user['username']}&email={$user['email']}&pg=";
	$tplData['paging'] = "";
	
	if ( $totalRecs > 0 )
	{
		$numPage = round($totalRecs / $perPage);
		
		if ( $numPage >= 10 )
		{
			//start pages
			if ( $curPage >= 4 )
			{
				$tplData['page']['st_ids'][1] = 1;
				$tplData['page']['st_ids'][2] = '...';
			}
			else 
			{
				for ( $i = 1; $i < $curPage; $i ++ )
				{
					$tplData['page']['st_ids'][$i] = $i;					
				}
			}
			// middle pages
			if ( $curPage < $numPage - 3 )
			{
				for ( $i = $curPage; $i <= $curPage + 2; $i++ )
				{
					if ( $curPage >= 4 )
					{
						$tplData['page']['st_ids'][$i-2] = $i-2;
						$tplData['page']['st_ids'][$i-1] = $i-1;
					}
					$tplData['page']['st_ids'][$i] = $i;
				}
			} 
			else
			{
				$tplData['page']['st_ids'][$numPage - 5] = $numPage - 5;
				$tplData['page']['st_ids'][$numPage - 4] = $numPage - 4;
				$tplData['page']['st_ids'][$numPage - 3] = $numPage - 3;
			}
			
			// end pages
			$tplData['page']['end_ids'][$numPage-3] = '...';
			for ( $i = $numPage-2; $i <= $numPage; $i++ )
			{
				$tplData['page']['end_ids'][] = $i;
			}
			$tplData['page']['multi'] = 1;
		}
		else if ( $numPage > 0 and $numPage < 10 )// we are not in multi pages
		{
			$tplData['page']['multi'] = 0;
			for ( $i = 1; $i <= $numPage; $i++ )
			{
				$tplData['page']['ids'][] = $i;
			}			
		} 
		
		
		if ( $numPage > 0 )
		{
			$tplData['paging'] = $msiPixel->disp->loadFile("bit/user_paging.tpl");
		}
		else 
		{
			$tplData['paging'] = "";
		}
	}
	
	// Start to query
	$sql = "SELECT * FROM {$msiPixel->db->_obj['prx']}member
				WHERE $condition
					ORDER BY username ASC LIMIT $end, $perPage";
	
	$result = $msiPixel->db->query($sql);
	
	// Parse content to template bit
	$tplData['rows'] = array();

	if ( $msiPixel->db->numRows($result) )
	{
		while ($row = $msiPixel->db->fetchArray($result))
		{
			$tplData['rows'][] = $row;
		}
		// Add to global Output
		$tplData['main'] .= $msiPixel->disp->loadFile("bit/user_search_result.tpl");
	}
	else
	{
		$msg = "Sorry! We do not find any record from your request";
		$msiPixel->disp->error($msg);
	}
}


//----### View edit user form ###----//
if ($action == "edit")
{
	$user = array();
	$user['email'] = $msiPixel->get('email', 'STR');

	if ( empty($user['email']) or !email_chk($msiPixel->db, $user['email']) )
	{
		$msg = "Error...missing/not valided email value. Please input right value.";
		$msiPixel->disp->error($msg);
	}
	else
	{
		//Populate user data
		$sql = "SELECT * FROM {$msiPixel->db->_obj['prx']}member WHERE lower(email) = '{$user['email']}'";
		$tplData = array_merge($tplData, $msiPixel->db->queryF($sql));

		//-----------------------------------------------
		//--- Hooks :: form_edituser
		//-----------------------------------------------
		$tplData['form_edituser'] = "";
		$plugins = getDB(0);
		foreach ($plugins as $plugin)
		{
        	$file_hook 	= ROOT_PATH.'/plugins/'.$plugin['name'].'/hook.php';

        	if ( file_exists($file_hook) )
        	{
        		require($file_hook);

    			$hookClass = 'hook_'.$plugin['name'];
    			$hookObj = new $hookClass();

    			if ( method_exists($hookObj, "form_edituser") )
    			{
        			$extDB = newDB($plugin, $msiPixel->db);
        			$tplData['form_edituser'] .= $hookObj->form_edituser($extDB, $tplData);
    			}
         		else
        		{
        		    $msg = "This feature is not available yet";
        		    $msiPixel->disp->error($msg);
        		}
        	}
		}
		$tplData['main'] .= $msiPixel->disp->loadFile('bit/user_edit.tpl');
	}

}


//----### Do update a user ###----//
if ($action == "doedit")
{
	$user = array();
	$user['username'] 	= $msiPixel->get('username', 'STR');
	$user['nickname'] 	= $msiPixel->get('nickname', 'STR');
	$user['password'] 	= $msiPixel->get('password', 'STR');
	$user['email'] 	  	= $msiPixel->get('email', 'STR');
	$user['newemail'] 	= $msiPixel->get('newemail', 'STR');
	$user['usergroup'] 	= $msiPixel->get('usergroup', 'INT');

	//-----------------------------------------------
	//--- Hooks :: edit_user
	//-----------------------------------------------
	$plugins = getDB(0);
	foreach ($plugins as $plugin)
	{
    	$file_hook 	= ROOT_PATH.'/plugins/'.$plugin['name'].'/hook.php';

    	if ( file_exists($file_hook) )
    	{
    		require($file_hook);

    		$hookClass = 'hook_'.$plugin['name'];
    		$hookObj = new $hookClass();

    		if ( method_exists($hookObj, "edit_user") )
    		{
        		$extDB = newDB($plugin, $msiPixel->db);
                $hookObj->edit_user($extDB, $user);
    		}
    		else
    		{
    		    $msg = "This feature is not available yet";
    		    $msiPixel->disp->error($msg);
    		}
     	}
	}

	// Redirect after processed successfully
	$url = "index.php?s=core&e=user&act=edit&email=".$user['newemail'];
	$msg = "Edit member successfully";
	$msiPixel->disp->redirect($msg, $url);
}



//----### Do delete a user ###----//
if ( $action == "dodelete" )
{
	$user = array();
	$user['emails'] = $msiPixel->get('emails');
	$user['email'] = $msiPixel->get('email');

	//Error or empty field
	if ( empty($user['email']) and empty($user['emails']) )
	{
		$msg = "Error...missing Email. Input right value before it can continue to do.";
		$msiPixel->disp->error($msg);
	}
	else
	{
		// checking if email is valid or not
		if ( empty($user['emails']) and email_chk($msiPixel->db, $user['email']) === false )
		{
			$msg = "Error...email address does not exist";
			$msiPixel->disp->error($msg);
		}

		$user['email'] = !empty($user['email']) ? array($user['email']) : $user['emails'];

		//-----------------------------------------------
		//--- Hooks :: delete_user
		//-----------------------------------------------
		$plugins = getDB(0);
		foreach ($plugins as $plugin)
		{
        	$file_hook 	= ROOT_PATH.'/plugins/'.$plugin['name'].'/hook.php';

        	if ( file_exists($file_hook) )
        	{
        		require($file_hook);

    			$hookClass = 'hook_'.$plugin['name'];
    			$hookObj = new $hookClass();

    			if ( method_exists($hookObj, "delete_user") )
    			{
                    $extDB = newDB($plugin, $msiPixel->db);
        			$hookObj->delete_user($extDB, $user);
    			}
        		else
        		{
        		    $msg = "This feature is not available yet";
        		    $msiPixel->disp->error($msg);
        		}
        	}
		}

		// Redirect after processed successfully
		$msg = "Deleted a member successfully";
		$msiPixel->disp->redirect($msg, "ref");
	}
}
?>