<?php
/*
 +----------------------------------------------------
 |  Multi system integration
 |  (c) 2004-2009 BBPixel.com
 +----------------------------------------------------
 |  Client User controller
 |  Revision: 0905160003 $
 |  Since: 2008-May-01
 |  Author: Koudanshi (sales@bbpixel.com)
 |  License: Commercial
 +----------------------------------------------------
 */



define("MSI_SYSTEM", 1);

require_once (dirname(__FILE__).'/init.php');

//----#### Request Activation code ###----//
if ( $action == 'actkey' )
{

}

//----#### Do Activation ###----//
if ( $action == 'activate' )
{
	$actKey = $msiPixel->get('key', 'STR');
	$email = $msiPixel->get('email', 'STR');

	$sql = "SELECT * FROM {$msiPixel->db->_obj['prx']}activation WHERE lower(email) = '{$email}'";
	$row = $msiPixel->db->queryF($sql);
	
	$currentTime = time();
	
	if ( $row['id'] == $actKey and $row['expired']  >= $currentTime )
	{
		//-----------------------------------------------
		//--- Hooks :: activate_user
		//-----------------------------------------------
		$user = array();
		$user['email'] = $email;

		$plugins = getDB(0);

		foreach ( $plugins as $plugin )
		{
	    	$file_hook = ROOT_PATH.'/plugins/'.$plugin['name'].'/hook.php';

	    	if ( file_exists($file_hook) )
	    	{
	    		require($file_hook);

	    		$hookClass = 'hook_'.$plugin['name'];
	    		$hookObj = new $hookClass();

	    		if ( method_exists($hookObj, "activate_user") )
	    		{
	            	$extDB = newDB($plugin, $msiPixel->db);
	        		$hookObj->activate_user($extDB, $user);
	    		}
	    		else
	    		{
	    		    $msg = "This feature is not available on {$plugin['name']} Plugin yet";
	    		    $msiPixel->disp->error($msg);
	    		}
	    	}
		}

		// Delete activation record
		$sql = "DELETE FROM {$msiPixel->db->_obj['prx']}activation WHERE lower(email) = '{$email}'";
		$msiPixel->db->query($sql);
		
		// Delete expired records
		$sql = "DELETE FROM {$msiPixel->db->_obj['prx']}activation WHERE expired < '{$currentTime}'";
		$msiPixel->db->query($sql);
		
		// Redirect
		$msg = $tplData['txt']['act_success'];
		$msiPixel->disp->redirect($msg);
	}
	else 
	{
	    $msg = $tplData['txt']['no_record'];
	    $msiPixel->disp->error($msg);				
	}
}



//----#### Do Recovery Password ###----//
if ( $action == 'dopwd' )
{
//echo "passed do password recovery action";
//exit;
	$reqKey = $msiPixel->get('key', 'STR');
	$email = $msiPixel->get('email', 'STR');

	$sql = "SELECT a.id, a.expired, m.username FROM {$msiPixel->db->_obj['prx']}activation a, {$msiPixel->db->_obj['prx']}member m 
				WHERE a.email = m.email
				AND lower(a.email) = '{$email}'
			";
	$row = $msiPixel->db->queryF($sql);
	//$msiPixel->_debug .= "<br />debug expired in db ".$row['expired'];
	///$msiPixel->_debug .= "<br> default expired value is ".$msiPixel->_expired;

	$currentTime = time();
	
	if ( $row['id'] == $reqKey and $row['expired']  > $currentTime )
	{
		$rawPwd = $msiPixel->genActKey(8);
		///$msiPixel->_debug .= "<br /> new password $rawPwd";
		//-----------------------------------------------
		//--- Hooks :: update_user
		//-----------------------------------------------
		$plugins = getDB(0);

		foreach ( $plugins as $plugin )
		{
	    	$file_hook = ROOT_PATH.'/plugins/'.$plugin['name'].'/hook.php';

	    	if ( file_exists($file_hook) )
	    	{
	    		require($file_hook);

	    		$hookClass = 'hook_'.$plugin['name'];
	    		$hookObj = new $hookClass();

	    		if ( method_exists($hookObj, "update_pwd") )
	    		{
	            	$extDB = newDB($plugin, $msiPixel->db);
	        		$hookObj->update_pwd($extDB, $rawPwd, $email);
	    		}
	    		else
	    		{
	    		    $msg = "This feature is not available on {$plugin['name']} Plugin yet";
	    		    $msiPixel->disp->error($msg);
	    		}
	    	}
		}
		
		// Update to Core user system 
		$sql = "UPDATE {$msiPixel->db->_obj['prx']}member SET imp_sys = 'core' WHERE lower(email) = '{$email}' ";
		$msiPixel->db->query($sql);
		
		// Delete temp passoword recovery request
		$sql = "DELETE FROM {$msiPixel->db->_obj['prx']}activation WHERE lower(email) = '{$email}'";
		$msiPixel->db->query($sql);
		// End Hook
		 
		
		// Do email notification
		$url = !empty($msiPixel->_cfg['urlAlias']) ? $msiPixel->_cfg['urlAlias'] : $msiPixel->_cfg['url'];
		$content = sprintf($tplData['txt']['pwd_new'], $row['username'], $rawPwd, $url, $msiPixel->_cfg['sitename']);
		$content = wordwrap($content, 70);
		$headers = "From: {$msiPixel->_cfg['sitename']} <{$msiPixel->_cfg['sitecontact']}>" . "\r\n" . "Reply-To: {$msiPixel->_cfg['sitename']} <{$msiPixel->_cfg['sitecontact']}>" . "\r\n" . 'X-Mailer: PHP/' . phpversion();
		@mail($email, $tplData['txt']['pwd_new_title'], $content, $headers);

		// Redirect
		$msg = $tplData['txt']['pwd_new_sent'];
		$msiPixel->disp->redirect($msg);

	}
	else 
	{
	    $msg = $tplData['txt']['no_record'];
	    $msiPixel->disp->error($msg);		
	}

}



?>