<?php
/*
 +----------------------------------------------------
 |  Multi system integration
 |  (c) 2004-2009 BBPixel.com
 +----------------------------------------------------
 |  Initial controller
 |  Revision: 0905160003 $
 |  Since: 2008-May-01
 |  Author: Koudanshi (sales@bbpixel.com)
 |  License: Commercial
 +----------------------------------------------------
 */



class hook_joomla
{

	/**
	 * Make Usergroup list
	 *
	 * @param object $db database
	 * @param object $tplData template data
	 * @return array list
	 */
	function makeListUG(&$db, &$tplData)
	{
		global $msiPixel;

		//------------------------------------------------
		//--- Get usergroup list
		//------------------------------------------------

		$sql = "SELECT id AS usergroupid, name AS title FROM {$db->_obj['prx']}core_acl_aro_groups WHERE id <> 17 and id <> 28";
		$result = $db->query($sql);

		while ($r = $db->fetchArray($result)) {
			$tplData['joom_gids'][$r['usergroupid']] = $r['title'];
		}

		$list = $msiPixel->disp->loadFile('bit/joomla/list_usergroup.tpl');

		return $list;
	}



	/**
	 * Hook add/edit user form
	 * Get Joomla user profiles/options
	 *
	 * @param string $db database object of Joomla
	 * @return $user array of key and values of each fields/options
	 */
	function form_edituser(&$db, &$tplData)
	{
		global $msiPixel;

		$tplData['joom_gid'] = 0;

		if ( !empty($tplData['email']) )
		{
			// Get current userGroupID from vBulletin
			$sql = "SELECT gid AS usergroupid, block FROM {$db->_obj['prx']}users WHERE lower(email) = '{$tplData['email']}' LIMIT 1";
			$row = $db->queryF($sql);
			$tplData['joom_gid'] = intval($row['usergroupid']);
			$tplData['joom_block'] = intval($row['block']);
		}

		// parse user group list
		$tplData['joom_usergroup'] = $this->makeListUG($db, $tplData);
		$form = $msiPixel->disp->loadFile('bit/joomla/form_edituser.tpl');

		return $form;
	}



	/**
	 * Hook add user
	 *
	 * @param unknown_type $user
	 */
	function add_user(&$db, $user=array())
	{
		global $msiPixel;

		$userType = 'Registered';
		$user['joom_block'] = $msiPixel->get('joom_block', 'INT');
		$user['joom_gid'] = $msiPixel->get('joom_gid', 'INT');
		$user['joom_gid'] = !empty($user['joom_gid']) ? $user['joom_gid'] : 18; // Registered group
		if ( MSI_AREA == "USER" and $msiPixel->_cfg['validEmail'] == true )
		{
			$user['joom_block'] = 1; // block
		}
        $password = $this->buildPassword($user['password']);
        $joined = $msiPixel->formatDate($user['joined']);

		$sql = "INSERT INTO {$db->_obj['prx']}users
					(`username`, `name`, `password`, `email`, `usertype`, `block`, `gid`, `registerDate`)
				VALUES
					('{$user['username']}', '{$user['nickname']}', '{$password}', '{$user['email']}', '$userType', {$user['joom_block']}, {$user['joom_gid']}, {$joined})
				";
		$db->query($sql);
		$userID = $db->insertID();

        $sql = "REPLACE INTO {$db->_obj['prx']}core_acl_aro
                    (`section_value`, `value`, `name`)
                VALUES
                    ('users', {$userID}, '{$user['username']}' )
                ";
		$db->query($sql);
		$aroID = $db->insertID();

		$sql = "REPLACE INTO {$db->_obj['prx']}core_acl_groups_aro_map
					(`group_id`, `aro_id`)
				VALUES
					({$user['joom_gid']}, {$aroID})
                ";
		$db->query($sql);
	}


	/**
	 * Hook edit user
	 *
	 * @param array $user input member data
	 */
	function edit_user(&$db, $user=array())
	{
		global $msiPixel;


		//usergroup initalize
		$user['joom_gid'] = $msiPixel->get('joom_gid', 'INT');
		$user['usertype'] = $this->getGroupName($db, $user['joom_gid']);
		$user['joom_block'] = $msiPixel->get('joom_block', 'INT');
		$userBlock = !empty($user['joom_block']) ? "block = {$user['joom_block']}," : "";
		$userType 	= !empty($user['joom_gid']) ? "usertype = '{$user['usertype']}'," : "";
		$userGroup 	= !empty($user['joom_gid']) ? "gid = {$user['joom_gid']}," : "";

		$sql = "UPDATE {$db->_obj['prx']}users
				SET username = '{$user['username']}',
					name = '{$user['nickname']}',
					{$userBlock}
					{$userType}
					{$userGroup}
					email = '{$user['newemail']}'
				WHERE lower(email) = '{$user['email']}'";
		$db->query($sql);

		if ( !empty($user['password']) )
		{
			$this->update_pwd($db, $user['password'], $user['email']);
		}

		if ( !empty($user['joom_gid']) )
		{
			// aro group
			$sql = "SELECT aa.id FROM {$db->_obj['prx']}core_acl_aro aa, {$db->_obj['prx']}users u
						WHERE aa.value = u.id
						AND lower(u.email) = '{$user['newemail']}'";
			$row = $db->queryF($sql);
			$aroID = $row['id'];

			// delete old record of core_acl_groups_aro_map
			$sql = "DELETE FROM {$db->_obj['prx']}core_acl_groups_aro_map WHERE aro_id IN ($aroID)";
			$db->query($sql);

			// insert new record for core_acl_groups_aro_map
			$sql = "REPLACE INTO {$db->_obj['prx']}core_acl_groups_aro_map
						(`group_id`, `aro_id`)
					VALUES
						({$user['joom_gid']}, {$aroID})
	                ";
			$db->query($sql);
		}
	}


	/**
	 * Update user password
	 * @param object $db database connectionn
	 * @param string $rawPwd plain text password
	 * @param string $email
	 */
	public function update_pwd(&$db, $rawPwd='', $email='')
	{
		if ( empty($rawPwd) or empty($email) ) return;

		$newPwd = $this->buildPassword($rawPwd);

		$sql = "UPDATE {$db->_obj['prx']}users
				SET password = '{$newPwd}'
				WHERE lower(email) = '{$email}'";
		$db->query($sql);
	}


	/**
	 * Hook delete a user
	 *
	 * @param string $db Database object of Joomla
	 * @param string array $user input data
	 */

	function delete_user(&$db, $user=array())
	{
		if (!empty($user['id']))
		{
			$this->do_delete_user($db, $user['id']);
		}
		else if ($user['email'] != null)
		{
			foreach ($user['email'] as $email)
			{
				$sql = "SELECT id FROM {$db->_obj['prx']}users WHERE lower(email) = '{$email}' LIMIT 1";
				$row = $db->queryF($sql);
				$userID = $row['id'];
				$this->do_delete_user($db, $userID);
			}
		}
	}



	function do_delete_user(&$db, $userID)
	{
		$sql = array();

		//User table
		$sql[] = "DELETE FROM {$db->_obj['prx']}users WHERE id IN ('{$userID}')";
		$sql[] = "DELETE aro, aro_map FROM {$db->_obj['prx']}core_acl_aro AS aro, {$db->_obj['prx']}core_acl_groups_aro_map AS aro_map WHERE aro.id = aro_map.aro_id AND aro.value IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}messages_cfg WHERE user_id IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}messages WHERE user_id_to IN ('{$userID}')";

		//execute
		foreach ($sql as $query)
		{
			$db->queryF($query);
		}
	}


	/**
	 * Hook activate a user
	 *
	 * @param string $db Database object of Core
	 * @param string array $user input data
	 */
	public function activate_user(&$db, $user=array())
	{
		// Update user
		$sql = "UPDATE {$db->_obj['prx']}users SET block = 0 WHERE lower(email) = '{$user['email']}'";
		$db->query($sql);
	}


	/**
	 * Get Joomla ACL Group name
	 *
	 * @param object $db database connection
	 * @param integer $id group ID
	 * @return string Group name
	 */
	function getGroupName(&$db, $id=0)
	{
		if (!$id) return "";

		$sql = "SELECT name FROM {$db->_obj['prx']}core_acl_aro_groups WHERE id = $id";
		$row = $db->queryF($sql);

		return $row['name'];
	}


	/**
	 * Hook isvalid_pwd
	 *
	 * @desc Checking if is validated password hass or not
	 *
	 * @param string $rawPwd plain text passwrd
	 * @param string $hashPwd hash password
	 * @param string $salt
	 *
	 * @return boolean
	 */
	public function isvalid_pwd($rawPwd='', $hashPwd='', $salt='')
	{
		if ( empty($rawPwd) or empty($hashPwd) )
		{
			return false;
		}

		$parts	= explode( ':', $hashPwd );
		$hashPwd = $parts[0];
		$salt	= @$parts[1];

		$chkPwd = md5($rawPwd.$salt);

		if ( $chkPwd != $hashPwd )
		{
			return false;
		}
		return true;
	}


	/**
	 * Hook recover user password
	 * @param object $db
	 * @param string $rawPwd plain text password
	 * @param string $email
	 */
	public function recover_pwd(&$db, $rawPwd='', $email='')
	{
		global $msiPixel;

		if ( empty($rawPwd) or empty($email) ) return ;

		$sql = "SELECT password FROM {$db->_obj['prx']}users WHERE lower(email) = '{$email}'";
		$row = $db->queryF($sql);
		$dbPwd = $row['password'];

		if ( $dbPwd == $msiPixel->_bbPwd )
		{
			$this->update_pwd($db, $rawPwd, $email);
		}
	}


	/**
	 * Hook sync_count
	 *
	 * @desc Re-counting statistic users records
	 * @return array user data
	 */
	function sync_count(&$db)
	{
		$sql = "SELECT COUNT(*) AS total FROM {$db->_obj['prx']}users
				WHERE 1";

		$result = $db->query($sql);

		$user = $db->fetchArray($result);

		return $user;
	}


	/**
	 * Hook sync_fix
	 *
	 * @desc Remove duplicate email, remove auto_increment param
	 */
	function sync_fix(&$db)
	{
		$sql = "SELECT u1.id FROM {$db->_obj['prx']}users u1, {$db->_obj['prx']}users u2
				WHERE u1.email = u2.email
				AND u1.id > u2.id";

		$result = $db->query($sql);

		while ($user = $db->fetchArray($result))
		{
			$this->do_delete_user($db, $user['id']);
		}

		/// Optimize database
		$sql = "ALTER TABLE {$db->_obj['prx']}users AUTO_INCREMENT = 0";
		$db->query($sql);
	}


	/**
	 * Get users data
	 *
	 * @param object $db database
	 * @param integer $start query starts from
	 * @param integer $offset how many records per request
	 */
	function sync_get_users(&$db, $start=0, $offset=0)
	{
		$user = array();
		$sql = "SELECT id, username, name AS nickname, email, password, UNIX_TIMESTAMP(registerDate) AS joined
			FROM {$db->_obj['prx']}users
			WHERE 1
			LIMIT {$start}, {$offset}
		";
		$result = $db->query($sql);
		while ($r = $db->fetchArray($result))
		{
			$r['imp_sys'] = 'joomla';
			$user[] = $r;
		}
		return $user;
	}




	/**
	 * Hook sync_add_user
	 *
	 * @param object $db database
	 * @param array $user input user data
	 */
	function sync_add_user(&$db, $user=array())
	{
	    global $msiPixel;

		//Checking duplicate username
		$uChkSql = "SELECT id, username AS name FROM {$db->_obj['prx']}users WHERE lower(username)='".strtolower($user['username'])."' LIMIT 1";
		$uChkRow = $db->queryF($uChkSql);

		if ( $uChkRow['id'] )
		{
			$user['username'] = ucfirst(substr($user['email'], 0, strpos($user['email'], "@")));
			$user['nickname'] = $user['username'];
		}

		//Checking duplicate email
		$mChkSql = "SELECT id FROM {$db->_obj['prx']}users WHERE lower(email)='".strtolower($user['email'])."' LIMIT 1";
		$mChkResult = $db->query($mChkSql);

		if ( !$db->numRows($mChkResult) )
		{
		    // force to use temp password
		    $salt = isset($user['salt']) ? $user['salt'] : "";
		    $user['password'] = $msiPixel->restorePwd($user['password'], $salt);
			$this->add_user($db, $user);
		}

	}



	/**
	 * Buid password
	 *
	 * @param string $password plain value
	 * @return unknown
	 */
	function buildPassword($password=null)
	{
	    global $msiPixel;

	    // don't build for temp sync password
	    // if ( $password == $msiPixel->_bbPwd ) return $password;

		//don't build for md5 pass
		if (strlen($password) == 32) return $password;

		$salt = $this->genSalt(32);
		$password = md5($password.$salt).":".$salt;

		return $password;
	}



	/**
	 * generate Joomla Salt
	 *
	 * @param interger $length
	 * @return string salt
	 */
	function genSalt($length=8)
	{

		$salt = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
		$len = strlen($salt);
		$makesalt = '';
		mt_srand(10000000 * (double) microtime());

		for ($i = 0; $i < $length; $i ++) {
			$makesalt .= $salt[mt_rand(0, $len -1)];
		}
		return $makesalt;
	}



}
?>