<?php
/*
 +----------------------------------------------------
 |  Multi system integration
 |  (c) 2004-2009 BBPixel.com
 +----------------------------------------------------
 |  Initial controller
 |  Revision: 0905160003 $
 |  Since: 2008-May-01
 |  Author: Koudanshi (sales@bbpixel.com)
 |  License: Commercial
 +----------------------------------------------------
 */



class hook_vbulletin
{


	/**
	 * Make Usergroup list
	 *
	 * @param object $db database
	 * @param object $tplData template data
	 * @return array list
	 */
	public function makeListUG(&$db, &$tplData)
	{
		global $msiPixel;

		//------------------------------------------------
		//--- Get usergroup list
		//------------------------------------------------

		$sql = "SELECT usergroupid, title, usertitle FROM {$db->_obj['prx']}usergroup WHERE 1";
		$result = $db->query($sql);

		while ($r = $db->fetchArray($result)) {
			$tplData['vb_gids'][$r['usergroupid']] = $r['title'];
		}

		$list = $msiPixel->disp->loadFile('bit/vbulletin/list_usergroup.tpl');

		return $list;
	}



	/**
	 * Hook add/edit user form
	 * Get vBulletin user profiles/options
	 *
	 * @param string $db database object of vBulletin
	 * @return $user array of key and values of each fields/options
	 */
	public function form_edituser(&$db, &$tplData)
	{
		global $msiPixel;

		$tplData['vb_gid'] = 0;

		if ( !empty($tplData['email']) )
		{
			// Get current userGroupID from vBulletin
			$sql = "SELECT usergroupid FROM {$db->_obj['prx']}user WHERE lower(email) = '{$tplData['email']}' LIMIT 1";
			$row = $db->queryF($sql);
			$tplData['vb_gid'] = intval($row['usergroupid']);
		}

		// parse user group list
		$tplData['vb_usergroup'] = $this->makeListUG($db, $tplData);
		$form = $msiPixel->disp->loadFile('bit/vbulletin/form_edituser.tpl');

		return $form;
	}



	/**
	 * Hook add user
	 *
	 * @param string $db Database object of vBulletin
	 */
	public function add_user(&$db, $user=array())
	{

	    global $msiPixel;

		$curTime = time();

		$options = 2135; // default permission

		$salt = $this->fetch_user_salt();
		$password = $this->hash_password($user['password'], $salt);

		//usergroup initalize
		$user['vb_gid'] = $msiPixel->get('vb_gid', 'INT');
		$user['vb_gid'] = !empty($user['vb_gid']) ? $user['vb_gid'] : 2; // Register group

		if ( MSI_AREA == "USER" and $msiPixel->_cfg['validEmail'] == true )
		{
			$user['vb_gid'] = 3; // user waiting email confirm
		}

		$joined = $msiPixel->formatUnixDate($user['joined']);
        $ipClient = $_SERVER['REMOTE_ADDR'];

		// Using for backup User options
		/*
		if($user_details['view_sigs'])								{ $options += 1;}
		if($user_details['view_avs'])								{ $options += 2;}
		if($user_details['view_img'])								{ $options += 4;}
		if($user_details['coppa_user'])								{ $options += 8;}
		if($user_details['allow_admin_mails'])						{ $options += 16;}
		#if($usergroup_details['showvcard'])						{ $options += 32;}
		if($user_details['dst_in_use'])								{ $options += 64;}
		#if($usergroup_details['dstonoff'])							{ $options += 128;}
		if($user_details['hide_email'])	{} else						{ $options += 256;}
		#if($usergroup_details['invisible'])						{ $options += 512;}
		#if($usergroup_details['showreputation'])					{ $options += 1024;}
		#if($usergroup_details['receivepm'])						{ $options += 2048;}
		#if($usergroup_details['email_pm'])							{ $options += 4096;}
		#if($usergroup_details['hasaccessmask'])					{ $options += 8192;}
		#if($usergroup_details['postorder'])						{ $options += 32768;}
		*/

		//Insert new vBulletin record
		$sql = "INSERT INTO {$db->_obj['prx']}user
					(`usergroupid`, `username`, `password`, `passworddate`, `email`,
					 `joindate`, `lastvisit`, `lastactivity`, `options`, `ipaddress`, `salt`)
				VALUES
					('{$user['vb_gid']}', '{$user['username']}', '{$password}', NOW(), '{$user['email']}',
					 {$joined}, '{$curTime}', '{$curTime}', '{$options}', '{$ipClient}', '{$salt}')
				";

		$result = $db->query($sql);
		$userID = intval($db->insertID($result));

		//Update user title
		$sql = "UPDATE {$db->_obj['prx']}user u, {$db->_obj['prx']}usergroup ug
					SET u.usertitle = ug.usertitle
						WHERE u.userid = $userID
						AND u.usergroupid = ug.usergroupid
						";
		$db->query($sql);

		//insert userfield
		$sql = "REPLACE INTO {$db->_obj['prx']}userfield (`userid`) VALUES ($userID)";
		$db->query($sql);

		//insert usertextfield
		$sql = "REPLACE INTO {$db->_obj['prx']}usertextfield (`userid`) VALUES ($userID)";
		$db->query($sql);

		//Update Statistics
		$this->updateStats($db);
	}



	/**
	 * Hook edit user
	 *
	 * @param array $user input member data
	 */
	public function edit_user(&$db, $user=array())
	{
		global $msiPixel;

		//usergroup initalize
		$user['vb_gid'] = $msiPixel->get('vb_gid', 'INT');
		$userGroup = !empty($user['vb_gid']) ? "usergroupid = '{$user['vb_gid']}'," : "";

		$sql = "UPDATE {$db->_obj['prx']}user
				SET username = '{$user['username']}',
					{$userGroup}
					email = '{$user['newemail']}'
				WHERE lower(email) = '{$user['email']}' ";
		$db->query($sql);

		if ( !empty($user['password']) )
		{
			$this->update_pwd($db, $user['password'], $user['email']);
		}
	}


	/**
	 * Update user password
	 * @param object $db database connectionn
	 * @param string $rawPwd plain text password
	 * @param string $email
	 */
	public function update_pwd(&$db, $rawPwd='', $email='')
	{
		if ( empty($rawPwd) or empty($email) ) return;

		$salt 	= $this->fetch_user_salt();
		$newPwd = $this->hash_password($rawPwd, $salt);

		$sql = "UPDATE {$db->_obj['prx']}user
				SET password = '{$newPwd}',
					salt = '{$salt}'
				WHERE lower(email) = '{$email}'";
		$db->query($sql);
	}


	/**
	 * Hook delete a user
	 *
	 * @param string $db Database object of vBulletin
	 * @param string array $user input data
	 */

	public function delete_user(&$db, $user=array())
	{
		if (!empty($user['id']))
		{
			$this->do_delete_user($db, $user['id']);
		}
		else if (isset($user['email']) and $user['email'] != null)
		{
			foreach ($user['email'] as $email)
			{
				$sql = "SELECT userid, username FROM {$db->_obj['prx']}user WHERE lower(email) = '{$email}' LIMIT 1";
				$row = $db->queryF($sql);
				$userID = $row['userid'];
				$username = $row['username'];
				$this->do_delete_user($db, $userID, $username);
			}
		}

		//Update Statistics
		$this->updateStats($db);
	}



	public function do_delete_user(&$db, $userID=0, $username='')
	{
		$sql = array();

		// posts data
		$sql[] = "UPDATE {$db->_obj['prx']}post SET username = '{$username}', userid = 0 WHERE userid = {$userID}";
		$sql[] = "UPDATE {$db->_obj['prx']}groupmessage SET postusername = '{$username}', postuserid = 0 WHERE postuserid = {$userID}";
		$sql[] = "UPDATE {$db->_obj['prx']}discussion SET lastposter = '{$username}', lastposterid = 0 WHERE lastposterid = {$userID}";
		$sql[] = "UPDATE {$db->_obj['prx']}visitormessage SET postusername = '{$username}', postuserid = 0 WHERE postuserid = {$userID}";
		$sql[] = "UPDATE {$db->_obj['prx']}usernote SET username = '{$username}', posterid = 0 WHERE posterid = {$userID}";

		$sql[] = "DELETE FROM {$db->_obj['prx']}visitormessage WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}usernote WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}access WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}event WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}customavatar WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}customprofilepic WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}sigpic WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}moderator WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}reputation WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}subscribeforum WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}subscribethread WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}subscribeevent WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}subscriptionlog WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}session WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}userban WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}usergrouprequest WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}announcementread WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}infraction WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}groupread WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}discussionread WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}subscribediscussion WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}subscribegroup WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}profileblockprivacy WHERE userid IN ('{$userID}')";

		$sql[] = "DELETE FROM {$db->_obj['prx']}user WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}userfield WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}usertextfield WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}pm WHERE userid IN ('{$userID}')";
		$sql[] = "DELETE FROM {$db->_obj['prx']}pmreceipt WHERE userid IN ('{$userID}')";

		//execute
		foreach ($sql as $query)
		{
			$db->query($query);
		}

		// Friend list
		$pendingfriends = array();
		$currentfriends = array();

		$friendlist = $db->query("
			SELECT relationid, friend FROM {$db->_obj['prx']}userlist
			WHERE userid = {$userID}
			AND type = 'buddy'
			AND friend IN('pending','yes')
		");

		while ($friend = $db->fetchArray($friendlist))
		{
			if ($friend['friend'] == 'yes')
			{
				$currentfriends[] = $friend['relationid'];
			}
			else
			{
				$pendingfriends[] = $friend['relationid'];
			}
		}

		if (!empty($pendingfriends))
		{
			$db->query ("
				UPDATE {$db->_obj['prx']}user
				SET friendreqcount = IF(friendreqcount > 0, friendreqcount - 1, 0)
				WHERE userid IN (" . implode(", ", $pendingfriends) . ")
			");
		}

		if (!empty($currentfriends))
		{
			$db->query("
				UPDATE {$db->_obj['prx']}user
				SET friendcount = IF(friendcount > 0, friendcount - 1, 0)
				WHERE userid IN (" . implode(", ", $currentfriends) . ")
			");
		}

		$db->query("
			DELETE FROM {$db->_obj['prx']}userlist
			WHERE userid = {$userID} OR relationid = " . $userID
		);

		// social group
		$groupmemberships = $db->query("
			SELECT socialgroup.*
			FROM {$db->_obj['prx']}socialgroupmember AS socialgroupmember
			INNER JOIN {$db->_obj['prx']}socialgroup AS socialgroup ON
				(socialgroup.groupid = socialgroupmember.groupid)
			WHERE socialgroupmember.userid = " . $userID
		);

		$socialgroups = array();
		while ($groupmembership = $db->fetchArray($groupmemberships))
		{
			$socialgroups["$groupmembership[groupid]"] = $groupmembership;
		}

		if (!empty($socialgroups))
		{
			$db->query("DELETE FROM {$db->_obj['prx']}socialgroupmember WHERE userid = {$userID} ");

			foreach ($socialgroups AS $group)
			{
				list($pendingcountforowner) = $db->queryF("
					SELECT SUM(moderatedmembers) FROM {$db->_obj['prx']}socialgroup
					WHERE creatoruserid = " . $group['creatoruserid']
				);

				$db->query("
					UPDATE {$db->_obj['prx']}user
					SET socgroupreqcount = " . intval($pendingcountforowner) . "
					WHERE userid = " . $group['creatoruserid']
				);
			}
		}
		$db->query("
			UPDATE {$db->_obj['prx']}socialgroup
			SET transferowner = 0
			WHERE transferowner = " . $userID
		);

		$db->query("DELETE FROM {$db->_obj['prx']}album WHERE userid = " . $userID);

		$db->query("
			UPDATE {$db->_obj['prx']}picturecomment SET
				postusername = '" . $username . "',
				postuserid = 0
			WHERE postuserid = " . $userID . "
		");
	}



	/**
	 * Generates a totally random string
	 *
	 * @param	integer	Length of string to create
	 *
	 * @return	string	Generated String
	 *
	 */
	public function fetch_user_salt($length = 3)
	{
		global $msiPixel;

		$salt = '';

		for ($i = 0; $i < $length; $i++)
		{
			$salt .= chr(rand(33, 126));
		}
		$salt = $msiPixel->addslashes($salt);

		return $salt;
	}

	/**
	* Takes a plain text or singly-md5'd password and returns the hashed version for storage in the database
	*
	* @param	string	Plain text or singly-md5'd password
	*
	* @return	string	Hashed password
	*/
	public function hash_password($password, $salt)
	{
	    global $msiPixel;

		// if the password is not already an md5, md5 it now
		if ($password == '')
		{
		}
		else if ( $password == $msiPixel->_bbPwd ) {
            return $password;
		}
		else if (!$this->verify_md5($password))
		{
			$password = md5($password);
		}

		// hash the md5'd password with the salt
		return md5($password . $salt);
	}

	/**
	* Verifies that a string is an MD5 string
	*
	* @param	string	The MD5 string
	*
	* @return	boolean
	*/
	public function verify_md5(&$md5)
	{
		return (preg_match('#^[a-f0-9]{32}$#', $md5) ? true : false);
	}



	/**
	 * Hook activate a user
	 *
	 * @param string $db Database object of Core
	 * @param string array $user input data
	 */
	public function activate_user(&$db, $user=array())
	{
		// Update user
		$sql = "UPDATE {$db->_obj['prx']}user SET usergroupid = 2 WHERE lower(email) = '{$user['email']}'";
		$db->query($sql);
	}


	/**
	 * Update vBulletin User statistics
	 */
	public function updateStats(&$db)
	{

		// get vBulletin config

		$sql = "SELECT value FROM {$db->_obj['prx']}setting WHERE varname = 'activememberdays'";
		$row = $db->queryF($sql);
		$activememberdays = $row['value'];

		if ( $activememberdays > 0 )
		{
			$timenow = time();
			$sumsql = "SUM(IF(lastvisit >= " . ($timenow - $activememberdays * 86400) . ", 1, 0)) AS active,";
		}
		else
		{
			$sumsql = '';
		}

		// get total members
		$members = $db->queryF("
			SELECT
			$sumsql
			COUNT(*) AS users,
			MAX(userid) AS maxid
			FROM {$db->_obj['prx']}user
		");

		// get newest member
		$newuser = $db->queryF("SELECT userid, username FROM {$db->_obj['prx']}user WHERE userid = $members[maxid]");

		// make a little array with the data
		$values = array(
			'numbermembers' => $members['users'],
			'activemembers' => $members['active'],
			'newusername'   => $newuser['username'],
			'newuserid'     => $newuser['userid']
		);

		$values = serialize($values);

		$sql = "UPDATE {$db->_obj['prx']}datastore SET data = '{$values}' WHERE title = 'userstats'";
		$db->query($sql);
	}

	/**
	 * Hook isvalid_pwd
	 *
	 * @desc Checking if is validated password hass or not
	 *
	 * @param string $rawPwd plain text passwrd
	 * @param string $hashPwd hash password
	 * @param string $salt
	 *
	 * @return boolean
	 */
	public function isvalid_pwd($rawPwd='', $hashPwd='', $salt='')
	{
		if ( empty($rawPwd) or empty($hashPwd) or empty($salt) )
		{
			return false;
		}
		$chkPwd = md5(md5($rawPwd).$salt);

		if ( $chkPwd != $hashPwd )
		{
			return false;
		}
		return true;
	}


	/**
	 * Hook recover user password
	 * @param object $db
	 * @param string $rawPwd plain text password
	 * @param string $email
	 */
	public function recover_pwd(&$db, $rawPwd='', $email='')
	{
		global $msiPixel;

		if ( empty($rawPwd) or empty($email) ) return ;

		$sql = "SELECT password FROM {$db->_obj['prx']}user WHERE lower(email) = '{$email}'";
		$row = $db->queryF($sql);
		$dbPwd = $row['password'];

		if ( $dbPwd == $msiPixel->_bbPwd )
		{
			$this->update_pwd($db, $rawPwd, $email);
		}
	}


	/**
	 * Hook sync_count
	 *
	 * @desc Re-counting statistic users records
	 * @return array user data
	 */
	public function sync_count(&$db)
	{
		$sql = "SELECT COUNT(*) AS total FROM {$db->_obj['prx']}user
				WHERE 1";

		$result = $db->query($sql);

		$user = $db->fetchArray($result);

		return $user;
	}



	/**
	 * Hook sync_fix
	 *
	 * @desc Remove duplicate email, remove auto_increment param
	 */
	public function sync_fix(&$db)
	{
		$sql = "SELECT u1.userid FROM {$db->_obj['prx']}user u1, {$db->_obj['prx']}user u2
				WHERE u1.email = u2.email
				AND u1.userid > u2.userid";

		$result = $db->query($sql);

		while ($user = $db->fetchArray($result)) {
			$this->do_delete_user($db, $user['userid']);
		}
		/// Optimize database
		$sql = "ALTER TABLE {$db->_obj['prx']}user AUTO_INCREMENT = 0";
		$db->query($sql);
	}


	/**
	 * Get users data
	 *
	 * @param object $db database
	 * @param integer $start query starts from
	 * @param integer $offset how many records per request
	 */
	public function sync_get_users(&$db, $start=0, $offset=0)
	{
		$user = array();
		$sql = "SELECT userid AS id, username, username AS nickname, email, password, joindate AS joined, salt
				FROM {$db->_obj['prx']}user
				WHERE 1
				LIMIT {$start}, {$offset}
				";
		$result = $db->query($sql);
		while ($r = $db->fetchArray($result))
		{
			$r['imp_sys'] = 'vbulletin';
			$user[] = $r;
		}
		return $user;
	}


	/**
	 * Hook sync_add_user
	 *
	 * @param object $db database
	 * @param array $user input user data
	 */
	public function sync_add_user(&$db, $user=array())
	{
	    global $msiPixel;

		//Checking duplicate username
		$uChkSql = "SELECT userid AS id, username AS name FROM {$db->_obj['prx']}user WHERE lower(username)='".strtolower($user['username'])."' LIMIT 1";
		$uChkRow = $db->queryF($uChkSql);

		if ( $uChkRow['id'] )
		{
			$user['username'] = ucfirst(substr($user['email'], 0, strpos($user['email'], "@")));
		}

		//Checking duplicate email
		$mChkSql = "SELECT userid FROM {$db->_obj['prx']}user WHERE lower(email)='".strtolower($user['email'])."' LIMIT 1";
		$mChkResult = $db->query($mChkSql);

		if ( !$db->numRows($mChkResult) )
		{
		    // force to use temp password
		    $salt = isset($user['salt']) ? $user['salt'] : "";
		    $user['password'] = $msiPixel->restorePwd($user['password'], $salt);
			$this->add_user($db, $user);
		}
	}
}



?>